#!/bin/bash
#Version: 1.1.0

#usage: export platform="linux-x86_64"; ./Build.sh

    #bug2 @ mac [ "root" == "$USER" ] || { echo "Build user $USER != root"; exit 1; }

    cd `dirname $0` ; srcDir=`pwd`
    echo "srcDir = $srcDir"

    [ "" == "$platform" ] && export platform="linux-x86_64"
    echo "$0 platform=$platform="

    bnCONFADD+=" TARGET_OS=$(echo $platform   | cut -d '-' -f1)"
    bnCONFADD+=" TARGET_ARCH=$(echo $platform | cut -d '-' -f2)"
    bnCONFADD+=" BUILD_DATE_TIME=$(date +%Y%m%d-%H:%M:%S)"
    bnCONFADD+=" pacdir=/opt/pac"
    bnCONFADD+=" platform=$platform"
    bnCONFADD+=" UNIX_SEC=$(date +%s)"
    #bnCONFADD+=" --disable-openssl"	#HAVE_SSL
    #bnCONFADD+=" --disable-proxy"	#bncSQLProxy_ENABLED
    #bnCONFADD+=" --disable-rsync"	#bncSQLRSync_ENABLED
    #bnCONFADD+=" --disable-bnssl"	#bnSSL_ENABLED
    #bnCONFADD+=" --enable-debug"	#bncSQL_DEBUG
    #CPPFLAGS+=" -v"			#bug4debug
    #CPPFLAGS+=" -DDEBUG=1"		#bug4debug
    #CPPFLAGS+=" -DbncSQLRSync_DEBUG=1"	#bug4debug
    #CPPFLAGS+=" -DbnRC4_DEBUG=1"	#bug4debug

    [ "arm-linux-androideabi" == "$platform" ] && {
    #aarch64-linux-android 2do
	bnCONFADD+=" --prefix=/opt/libbncsql-$platform"
	CPPFLAGS_SAFE="$CPPFLAGS"
	CPPFLAGS=""
	. /opt/arm-linux-androideabi/toolchain/androideabi || exit 2 #2do set xxxFLAGS+="xxxx"
	CPPFLAGS+="$CPPFLAGS_SAFE"
    } #[ "arm-linux-androideabi" == "$platform" ]

    [ "windows-x86_64" == "$platform" ] && {
	bnCONFADD+=" --prefix=/opt/libbncsql-$platform"
	bnCONFADD+=" TOOLCHAIN=/usr/x86_64-w64-mingw32"
	bnCONFADD+=" TARGET=x86_64-w64-mingw32"
    } #[ "windows-x86_64" == "$platform" ]

    [ "windows-i686" == "$platform" ] && {
	bnCONFADD+=" --prefix=/opt/libbncsql-$platform"
	bnCONFADD+=" TOOLCHAIN=/usr/i686-w64-mingw32"
	bnCONFADD+=" TARGET=i686-w64-mingw32"
    } #[ "windows-i686" == "$platform" ]

    [ "linux-x86_64" == "$platform" ] && {
    #linux-i686 2do
	bnCONFADD+=" --prefix=/opt/libbncsql-$platform"
	CXXFLAGS+="$CPPFLAGS"
	CXXFLAGS+=" -D_GLIBCXX_USE_CXX11_ABI=0" #libstdc++ -> ver 3.4 #linux only
    } #[ "linux-x86_64" == "$platform" ]

    [ "osx-x86_64" == "$platform" ] && {
    #2do osx-i386, export ARCH="i386";
	bnCONFADD+=" --prefix=/opt/libbncsql-osx-x86_64" #2do /opt -> /opt
	#CPPFLAGS+=" -I$HOME/kivy-ios/dist/root/python/include/python2.7"
	#LDFLAGS+=" -L$HOME/kivy-ios/dist/lib -lpython"
    } #[ "ios-arm64" == "$platform" ]

    [ "ios-arm64" == "$platform" ] && {
	bnCONFADD+=" --prefix=/opt/libbncsql-ios" #2do /opt -> /opt
	CPPFLAGS+=" -I$HOME/kivy-ios/dist/root/python/include/python2.7"
	LDFLAGS+=" -L$HOME/kivy-ios/dist/lib -lpython"
    } #[ "ios-arm64" == "$platform" ]

    [ "ios-armv7" == "$platform" ] && {
	bnCONFADD+=" --prefix=/opt/libbncsql-ios" #2do /opt -> /opt
	CPPFLAGS+=" -I$HOME/kivy-ios/dist/root/python/include/python2.7" #2do HOME
	LDFLAGS+=" -L$HOME/kivy-ios/dist/lib -lpython"
    } #[ "ios-armv7" == "$platform" ]

    echo "bnCONFADD=$bnCONFADD="
    export CPPFLAGS CXXFLAGS LDFLAGS
    [ -e configure ] || autoconf.sh
    [ -e Makefile  ] || ./configure $bnCONFADD || exit 3
          make         || exit 4
          make install || exit 5
    #sudo make install || exit 5
          make run     || exit 6
          make pac   #skip error, 2do @ os-x  || exit 7
    echo "$0 platform=$platform="
    exit 0
