//Copyright 2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
//#include <ctype.h>
//#include <locale.h>


#include <bncsql.h>
//#define bncSQL_DEBUG
#include <albus_log.h>
#ifndef bncSQL_DEBUG
# undef  ER
# define ER
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif

//#define D9 D1

#include <xls.h>
using namespace xls;

long  xlsread_API_Version = bncSQL_API_VERSION;
char  xlsread_Version[]   = "1.0.0";


extern "C" {


char *xlsread_dbOpen ( _bncDataBase *db ) {
    D9 ( "db=%p", db );

char *Error = db->Error;
    if ( Error[0] ) return NULL;

//error check
    if ( ! db     ) return NULL;
    if ( db->Conn ) return Error; //already open

    D2 ( "db->Host=%s" , db->Host );
    D2 ( "db->Port=%ld", db->Port );
    D2 ( "db->Base=%s" , db->Base );
    D2 ( "db->User=%s" , db->User );
    D9 ( "db->Pass=%s" , db->Pass );//D9

char MyFile[255];
    sprintf ( MyFile, "%s/%s", db->Host, db->Base );
    xlsWorkBook *pWB = xls_open ( MyFile, (char *)"utf8" ); //2do xls_open ( MyFile, (char *)db->Encoding );
    //xls_getVersion();
    if ( ! pWB ) SER  ( "! pWB"			);

    db->Conn = (xlsWorkBook *)pWB;

    D9 ( "db->Conn=%p", db->Conn );//D9

//all OK
    return NULL;

}//char *xlsread_dbOpen ( _bncDataBase *db )


char *xlsread_dbClose ( _bncDataBase *db ) {
    D9 ( "db=%p", db );

char *Error = db->Error;

//error check
    if ( ! db       ) return NULL;
    if ( ! db->Conn ) return NULL; //already closed

    D9 ( " db->Base=%s", db->Base );
    D9 ( " db->Host=%s", db->Host );

    free ( db->Conn );
    db->Conn = NULL;

    return NULL;

}//char *xlsread_dbClose ( _bncDataBase *db )


char *xlsread_tbOpen ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

//error check
    if ( ! tb ) return NULL;

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

    //tb->FieldNameRow = 1; //bug4debug

//error check
    if ( ! tb->db       ) SER ( "! tb->db"       );
    if ( ! tb->db->Conn ) SER ( "! tb->db->Conn" );
    if ( ! tb->Query    ) SER ( "! tb->Query"    );
    if ( ! tb->Query[0] ) SER ( "! tb->Query[0]" );
    if (   tb->Result   ) return NULL; //alreay open

    D9 ( "tb->Query=~%s~", tb->Query );

xlsWorkBook	*pWB = (xlsWorkBook *)tb->db->Conn;

    if ( strcmp ( tb->Query, "show tables" ) == 0 ) {
	//for ( int i = 0 ; i < pWB->sheets.count ; i++ ) D9 ( "i=%03d filepos=%03d name=~%s~", i, pWB->sheets.sheet[i].filepos, pWB->sheets.sheet[i].name ); //bug4debug
    //amount of Records
	tb->Records	= pWB->sheets.count;
	D9 ( "tb->Records=%ld", tb->Records );
    //amount of Fields
	tb->Fields	= 1;
    //all OK
	tb->Result	= tb;
    }//if ( strcmp ( tb->Query, "show tables" ) == 0 )
    else if ( strncmp ( tb->Query, "select * from ", strlen ( "select * from " ) ) == 0 ) {
    char *tb__Name = tb->Query + strlen ( "select * from " );
	D9 ( "tb__Name=~%s~", tb__Name );

    long WSOpen = 0;
	for ( int i = 0 ; i < pWB->sheets.count ; i++ ) {
	    if ( strcmp ( (char *)pWB->sheets.sheet[i].name, tb__Name ) == 0 ) WSOpen = i + 1;
	    if ( WSOpen ) break;
	}//for ( int i = 0 ; i < pWB->sheets.count ; i++ )
	if ( ! WSOpen ) SER ( "Table ~%s~ not Found", tb__Name );
	D9 ( "WSOpen=%ld", WSOpen );

    xlsWorkSheet *pWS = xls_getWorkSheet ( pWB, WSOpen - 1 );
	if ( ! pWS ) SER  ( "! pWS" );
	xls_parseWorkSheet ( pWS );
	//printf ( "<style type=\"text/css\">\n%s</style>\n",xls_getCSS ( pWB ) ); //bug4debug

    //amount of Records
	tb->Records = pWS->rows.lastrow + 1;

	if ( tb->FieldNameRow ) {
	    if ( 1 <= tb->Records ) {
		tb->Records -= 1;
	    }
	}

	D9 ( "tb->Records=%ld", tb->Records );
    //amount of Fields
	tb->Fields  = pWS->rows.lastcol;
	D9 ( "tb->Fields=%ld", tb->Fields );
    //all OK
	tb->Result = (xlsWorkSheet *)pWS;

    }//else if ( strncmp ( tb->Query, "select * from ", strlen ( "select * from " ) ) == 0 )
    else SER ( "unknown query=%s", tb->Query );

    return NULL;

}//char *xlsread_tbOpen ( _bncTable *tb )


_bncColumn *xlsread_tbColumnInsert ( _bncTable *tb, _bncColumn *co, unsigned long ColumnInsertFokus ) {
    D9 ( "tb=%p", tb );

    if ( ! tb ) return NULL;

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

    if ( ! tb->Result ) SER ( "! tb->Result" );

//show tables work around
    if ( strcmp ( tb->Query, "show tables" ) == 0 ) {
	 co->Name = strdup ( "name" );
	 co->Type = bn_char;
	*co->Size = 255;
	return co;
    }//if ( strcmp ( tb->Query, "show tables" ) == 0 )
    else {
	D9 ( "ColumnInsertFokus=%ld", ColumnInsertFokus );
    char co__Name[255] = ""; //old char	*myName = new char[20];
	if ( tb->FieldNameRow ) {
	xlsWorkSheet               *pWS = (xlsWorkSheet *)tb->Result;
	struct st_row::st_row_data *row = &pWS->rows.row[ 0 ];
	char *xlsRowName = (char *)row->cells.cell[ ColumnInsertFokus ].str;
	    if ( xlsRowName ) {
		if ( xlsRowName[0] ) {
		    sprintf ( co__Name, "%s", xlsRowName );
		}
	    }//if ( xlsRowName )
	}//if ( tb->FieldNameRow )
	else {
	    sprintf ( co__Name, "A%05ld", ColumnInsertFokus );
	}
	if ( ! co__Name[0] ) SER ( "! co__Name[0]" );
	 co->Name = strdup ( co__Name );
	 co->Type = bn_char;
	*co->Size = 255; //2do ???
	return co;
    }//else if ( strcmp ( tb->Query, "show tables" ) == 0 )

    return NULL;

}//_bncColumn *xlsread_tbColumnInsert ( _bncTable *tb, _bncColumn *co, unsigned long ColumnInsertFokus )


char *xlsread_tbClose ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

//error check
    if ( ! tb ) return NULL;

char *Error = tb->Error;

    if ( ! tb->Result ) return NULL; //not open

    D9 ( "tb->Name=%s", tb->Name );
    //2do glibc double free or corruption ... free ( tb->Result ); //delete tb->Result;
    tb->Result   = NULL;
    tb->Records  = 0;
    tb->Fields   = 0;
    tb->Error[0] = 0;
    tb->Fokus    = 0;

    return NULL;

}//char *xlsread_tbClose ( _bncTable *tb )


char *xlsread_tbColumn ( _bncTable *tb, const char *ColumnName, unsigned char **ret_data, unsigned long *ret_len ) {
    D9 ( "tb=%p", tb );

//error check
    if ( ! tb ) return NULL;

char *Error = tb->Error;

    *ret_data = NULL;
    *ret_len  =    0;

    if ( Error[0]        ) return NULL;
    if ( ! tb->Records   ) return NULL;
    if ( ! tb->Result    ) SER ( "! tb->Result"    );
    if ( ! ColumnName    ) SER ( "! ColumnName"    );
    if ( ! ColumnName[0] ) SER ( "! ColumnName[0]" );
    if ( ! ret_data      ) SER ( "! ret_data"      );
    if ( ! ret_len       ) SER ( "! ret_len"       );

    D9 ( "tb->Fokus=%ld", tb->Fokus  );
    D9 ( "ColumnName=%s", ColumnName );
    D9 ( "ret_data  =%p", ret_data   );
    D9 ( "ret_len   =%p", ret_len    );

    if ( tb->FieldNameRow ) tb->FieldNameRow = 1;//set always to first row, 2do FieldTypeRow

    if ( strcmp ( tb->Query, "show tables" ) == 0 ) {
    xlsWorkBook *pWB = (xlsWorkBook *)tb->db->Conn;
	*ret_data = (unsigned char *)pWB->sheets.sheet[ tb->Fokus - 1 ].name;
	*ret_len  = strlen ( (char *)*ret_data );
	return NULL;
    }//if ( strcmp ( tb->Query, "show tables" ) == 0 )
    else {
    xlsWorkSheet               *pWS = (xlsWorkSheet *)tb->Result;
    xlsWorkBook                *pWB = (xlsWorkBook  *)tb->db->Conn;

    char co__Name[255] = "";
    unsigned long FieldIndex = 0;
	for ( unsigned long FieldsPos = 0; FieldsPos < tb->Fields; FieldsPos++ ) {
	    D9 ( "FieldsPos=%ld", FieldsPos );
	    if ( tb->FieldNameRow ) {
	    struct st_row::st_row_data *row = &pWS->rows.row[ 0 ];
	    char *xlsRowName = (char *)row->cells.cell[ FieldsPos ].str;
		if ( xlsRowName ) {
		    if ( xlsRowName[0] ) {
			sprintf ( co__Name, "%s", xlsRowName );
		    }
		}//if ( xlsRowName )
	    }//if ( tb->FieldNameRow )
	    else {
		sprintf ( co__Name, "A%05ld", FieldsPos );
	    }
	    D9 ( "co__Name=%s", co__Name );
	    if ( strcmp ( ColumnName, co__Name ) == 0 ) {
		FieldIndex = FieldsPos + 1;
		break;
	    }
	}//for ( unsigned long FieldsPos = 0; FieldsPos < tb->Fields; FieldsPos++ )
	if ( ! FieldIndex ) return NULL;
	D9 ( "FieldIndex=%ld", FieldIndex );

    struct st_row::st_row_data *row = &pWS->rows.row[ tb->Fokus - 1 + tb->FieldNameRow ]; //2do FieldTypeRow

	D9 ( "row->cells.cell[FieldIndex - 1].str=~%s~", row->cells.cell[FieldIndex - 1].str );
	if ( row->cells.cell[FieldIndex - 1].str ) {
	    *ret_data = (unsigned char *)row->cells.cell[FieldIndex - 1].str;
	    *ret_len  = strlen ( (char *)*ret_data );
	}
	return NULL;

    }//else if ( strcmp ( tb->Query, "show tables" ) == 0 )

    return NULL;

}//char *xlsread_tbColumn ( _bncTable *tb, const char *ColumnName, unsigned char **ret_data, unsigned long *ret_len )


char *xlsread_tbRecord ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

//fetch record, done in tbColumn via Fokus
    return NULL;

}//char *xlsread_tbRecord ( _bncTable *tb )


char *xlsread_tbSQLBuild ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
    if ( Error[0] ) return NULL;

    return NULL;

}//char *xlsread_tbSQLBuild ( _bncTable *tb )


char *xlsread_coDEF ( _bncColumn *co ) {
    D9 ( "co=%p", co );
char *Error = co->Error;
    if ( Error[0] ) return NULL;

    return NULL;

}//char *xlsread_coDEF ( _bncColumn *co )


}//extern "C"
