//Copyright 2016-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifdef HAVE_CONFIG
# include <config.h>
#endif
#include <albus_log.h>

//#define DEBUG
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <stdarg.h>
#ifdef __ANDROID__
# include <android/log.h>
#else
# ifndef WIN32
#  include <syslog.h>
# endif
#endif
//syslog.h 2do @ win32


int   albus_log_init_done    = 0;
int   albus_log_syslog       = 0;
int   albus_log_level        = 0;
FILE *albus_log_file_stream  = NULL;
char *albus_log_file         = NULL;
FILE *albus_log_stdio_stream = NULL;
char *albus_log_stdio        = NULL;
char *albus_log_modul        = NULL;
long albus_log_mi_last_free  = 0;
long albus_log_mi_last_offset= 0;


void albus_log ( int l_level, char *Error, char *Modul, const char *Function, long FunctionLine, const char *format, ... ) {
//albus_log_file_stream = stderr;//bug 2do Mac .so
#ifdef DEBUG
    //albus_log_stdio = strdup ( "stderr" );//bug4debug
    albus_log_level = 9;
#endif
    if ( ( albus_log_file ) && ( ! albus_log_file_stream  ) && ( albus_log_file[0]  ) ) {//2do mv 2 open, else always check...
	albus_log_file_stream = fopen ( albus_log_file, "at" );
    }
    if ( ( albus_log_stdio ) && ( ! albus_log_stdio_stream ) && ( albus_log_stdio[0] ) ) {//2do mv 2 open, else always check...
	if      ( strcmp ( "stdout", albus_log_stdio ) == 0 ) { albus_log_stdio_stream = stdout; }
	else if ( strcmp ( "stderr", albus_log_stdio ) == 0 ) { albus_log_stdio_stream = stderr; }
    }

    if ( AL_ER == l_level ) {}
    else if ( albus_log_level < l_level ) {
	return;
    }

char xbuffer[64000];

va_list arg;
    va_start ( arg, format );
    vsprintf ( xbuffer, format, arg );
    va_end   ( arg );

time_t sec = 0;
    time ( &sec );
struct tm *TM = localtime ( &sec );
char xheader[255] = "";
    strftime ( xheader, 80, "%d.%m.%Y %X ", TM );

    if ( Modul ) {
	strcat ( xheader, Modul );
	strcat ( xheader, " " );
    }
    if ( AL_ER == l_level ) {
	strcat ( xheader, "Error:" );
    }
    if ( Function ) {
	if ( FunctionLine ) {
	    sprintf ( xheader, "%s%40s[%04ld]", xheader, Function, FunctionLine );
	}
	else {
	    sprintf ( xheader, "%s%40s"       , xheader, Function );
	}
	strcat ( xheader, ":" );
    }

    if ( Error ) {
	sprintf (          Error, "%s%s"  , xheader, xbuffer );
    }

//#ifdef DEBUG
//fprintf ( stderr, "%s%s\n", xheader, xbuffer ); fflush  ( stdout );
//#endif

//destinations
    if ( albus_log_stdio_stream ) {
	fprintf ( albus_log_stdio_stream, "%s%s\n", xheader, xbuffer );
	fflush  ( albus_log_stdio_stream );
    }

    if ( albus_log_file_stream ) {
	fprintf ( albus_log_file_stream, "%s%s\n", xheader, xbuffer );
	fflush  ( albus_log_file_stream );
    }

    if ( albus_log_syslog ) {
#ifdef __ANDROID__
    android_LogPriority priority;
    const char *tag = "python"; //2do = albus
	//iority = ANDROID_LOG_SILENT;
	//iority = ANDROID_LOG_VERBOSE;
	//iority = ANDROID_LOG_DEBUG;
	priority = ANDROID_LOG_INFO;
	//iority = ANDROID_LOG_WARN;
	//iority = ANDROID_LOG_ERROR;
	//iority = ANDROID_LOG_FATAL;
	//iority = ANDROID_LOG_SILENT;
	//iority = ANDROID_LOG_DEFAULT;
	//iority = ANDROID_LOG_UNKNOWN;
	__android_log_print(priority, tag, "%s%s", xheader, xbuffer );
#endif
#ifdef __linux__
# ifndef __ANDROID__
    char buffer[4096];
	sprintf ( buffer, "%s%s", xheader, xbuffer );
	syslog  ( LOG_INFO, buffer );//linux ok
# endif
#endif
    }//if ( albus_log_syslog )

    return;

}//void albus_log ( int l_level, char *Error, char *Modul, const char *Function, long FunctionLine, const char *format, ... )


char *albus_log_set ( const char *Key, const char *Val ) {
    D9 ( "Key=~%s~ Val=~%s~", Key, Val );

    if ( 1 == 0 ) {}
    else if ( strcmp (           "level" , Key ) == 0 ) albus_log_level  = atol ( Val );
    else if ( strcmp ( "albus_log_level" , Key ) == 0 ) albus_log_level  = atol ( Val );
    else if ( strcmp (           "syslog", Key ) == 0 ) albus_log_syslog = atol ( Val );
    else if ( strcmp ( "albus_log_syslog", Key ) == 0 ) albus_log_syslog = atol ( Val );
    else if ( strcmp (           "stdio" , Key ) == 0 ) {
	if ( strlen ( Val ) ) albus_log_stdio  = strdup ( Val );
	else                  albus_log_stdio  = NULL;
    }
    else if ( strcmp ( "albus_log_stdio" , Key ) == 0 ) {
	if ( strlen ( Val ) ) albus_log_stdio  = strdup ( Val );
	else                  albus_log_stdio  = NULL;
    }
    else if ( strcmp (           "file"  , Key ) == 0 ) {
	if ( strlen ( Val ) ) albus_log_file  = strdup ( Val );
	else                  albus_log_file  = NULL;
    }
    else if ( strcmp ( "albus_log_file"  , Key ) == 0 ) {
	if ( strlen ( Val ) ) albus_log_file  = strdup ( Val );
	else                  albus_log_file  = NULL;
    }

    return NULL;

}//char *albus_log_set ( const char *Key, const char *Val )
