//Copyright 2017 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//2do csv with header
#ifdef HAVE_CONFIG
# include <config.h>
#endif
#include "bnSplitPos.h"
#include <string.h>

#include <albus_log.h>
#ifndef bnSplitPos_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif


#ifdef WIN32
static char *strndup( const char *a, size_t b) {
char *c = (char *)malloc (b+1);
    memset  ( c, 0x00, b+1 );
    strncpy ( c,    a, b   );
    return c;
}
#endif


unsigned long IgnoreBeg ( const char *Input, unsigned long InputLen, char *Ignore, unsigned long IgnoreLen, char *Quote, int DeQuote ) {
    D9 ( "call" );

    if ( ! Input     ) return 0;
    if ( ! InputLen  ) return 0;
    if ( ! Ignore    ) return 0;
    if ( ! IgnoreLen ) return 0;

unsigned long Beg = 0;
unsigned long InputPos = 0;
    for ( InputPos = 0; InputPos < InputLen; InputPos++ ) {
	D9 ( "Input[%04ld]=~%c~", InputPos, Input[InputPos] );
    long IgnoreChar = 0;
    unsigned long IgnorePos = 0;
	for ( IgnorePos = 0; IgnorePos < IgnoreLen; IgnorePos++ ) {
	    D9 ( "Ignore[%04ld]=~%c~", IgnorePos, Ignore[IgnorePos] );
	    if ( Ignore[IgnorePos] == Input[InputPos] ) IgnoreChar = 1;
	}//for ( unsigned long IgnorePos = 0; IgnorePos < IgnoreLen; IgnorePos++ )
	if ( IgnoreChar ) Beg = InputPos + 1;
	else              break;
    }//for ( unsigned long InputPos = 0; InputPos < InputLen; InputPos++ )

    if ( DeQuote ) {
	if ( Quote ) {
	    if ( Quote[0] == Input[Beg] ) Beg++;
	}
    }

    return Beg;

}//unsigned long IgnoreBeg ( char *Input, unsigned long InputLen, char *Ignore, unsigned long IgnoreLen, char *Quote, int DeQuote )


unsigned long IgnoreEnd ( const char *Input, unsigned long InputLen, char *Ignore, unsigned long IgnoreLen, char *Quote, int DeQuote ) {
    D9 ( "call" );

    if ( ! Input     ) return 0;
    if ( ! InputLen  ) return 0;
    if ( ! Ignore    ) return InputLen;
    if ( ! IgnoreLen ) return InputLen;

unsigned long Len = InputLen;

long InputPos = InputLen - 1;
    while ( 0 <= InputPos ) {
	D9 ( "Input[%04ld]=~%c~", InputPos, Input[InputPos] );
    long IgnoreChar = 0;
    unsigned long IgnorePos = 0;
	for ( IgnorePos = 0; IgnorePos < IgnoreLen; IgnorePos++ ) {
	    D9 ( "Ignore[%04ld]=~%c~", IgnorePos, Ignore[IgnorePos] );
	    if ( Ignore[IgnorePos] == Input[InputPos] ) IgnoreChar = 1;
	}//for ( unsigned long IgnorePos = 0; IgnorePos < IgnoreLen; IgnorePos++ )
	if ( IgnoreChar ) Len = InputPos;
	else              break;
	InputPos--;
    }//while ( 0 <= InputPos )

    if ( ! Len ) return Len;

    if ( DeQuote ) {
	if ( Quote ) {
	    if ( Quote[0] == Input[Len - 1] ) Len--;
	}
    }

    return Len;
}//unsigned long IgnoreEnd ( char *Input, unsigned long InputLen, char *Ignore, unsigned long IgnoreLen, char *Quote, int DeQuote )


unsigned long DoubleQuoteDrop ( char *Input, unsigned long InputLen, char *Quote ) {
    D9 ( "call" );

    if ( ! Input     ) return 0;
    if ( ! InputLen  ) return 0;

    D9 ( "Input   =~%s~", Input    );
    D9 ( "InputLen=%ld" , InputLen );

unsigned long Offset = 0;
unsigned long InputPos = 0;
    for ( InputPos = 0; InputPos < InputLen; InputPos++ ) {
	D9 ( "Input[%04ld]=~%c~ Offset=%04ld", InputPos, Input[InputPos], Offset );
	if      ( ( Quote[0] == Input[InputPos] ) && ( Quote[0] == Input[InputPos+1] ) ) { Offset++; InputPos++; }
	else if ( ( '\\'     == Input[InputPos] ) && ( Quote[0] == Input[InputPos+1] ) ) { Offset++; InputPos++; }
	D9 ( "CP  t[%04ld]=~%c~ Offset=%04ld", InputPos       , Input[InputPos       ], Offset );
	D9 ( "CP  t[%04ld]=~%c~ Offset=%04ld", InputPos+Offset, Input[InputPos+Offset], Offset );
	if ( Offset ) Input[InputPos-Offset] = Input[InputPos];
    }//for ( unsigned long InputPos = 0; InputPos < InputLen; InputPos++ )
    D9 ( "Input=~%s~", Input );
    return InputLen - Offset;

}//unsigned long DoubleQuoteDrop ( char *Input, unsigned long InputLen, char *Quote )


_bnSplitPos *bnSplitPosNew ( const char *Input, long  InputLen ) {
    D9 ( "call" );
_bnSplitPos *bnSplitPos = (_bnSplitPos *)malloc ( sizeof (_bnSplitPos) );
    if ( !   bnSplitPos ) return NULL;
    memset ( bnSplitPos, 0x00, sizeof ( _bnSplitPos ) );

    bnSplitPos->Delimiter = ',';
    bnSplitPos->Quote     = (char *)"\"";
    bnSplitPos->DeQuote   = 1;
    bnSplitPos->Ignore    = (char *)" 	\r";
    bnSplitPos->IgnoreLen = strlen ( bnSplitPos->Ignore );

    if ( Input ) {
			      bnSplitPos->Input    =          Input;
	if ( -1 == InputLen ) bnSplitPos->InputLen = strlen ( Input );
	else                  bnSplitPos->InputLen = InputLen;
    }

    return bnSplitPos;

}//_bnSplitPos *bnSplitPosNew ( char *Input, long  InputLen )


void bnSplitPosShow ( _bnSplitPos *bnSplitPos ) {
    D9 ( "call" );

    D1 ( "bnSplitPos= %p"     , bnSplitPos           );
    if ( ! bnSplitPos ) return;
    D1 ( " Input    = %p"     , bnSplitPos->Input    );
    if ( bnSplitPos->Input )
    D1 ( " Input    = ~%s~"   , bnSplitPos->Input    );
    D1 ( " InputLen = %04ld"  , bnSplitPos->InputLen );
    D1 ( " Beg      = %04ld"  , bnSplitPos->Beg      );
    D1 ( " Len      = %04ld"  , bnSplitPos->Len      );

    D1 ( " Ignore   = %p"     , bnSplitPos->Ignore   );
    if ( bnSplitPos->Ignore )
    D1 ( " Ignore   = ~%s~"   , bnSplitPos->Ignore, bnSplitPos->Ignore   );
    D1 ( " IgnoreLen= %04ld"  , bnSplitPos->IgnoreLen);

    D1 ( " Record   = %p"     , bnSplitPos->Record   );
    D1 ( " Records  = %04ld"  , bnSplitPos->Records  );

}//void bnSplitPosShow ( _bnSplitPos *bnSplitPos )


void bnSplitPosFree ( _bnSplitPos *bnSplitPos ) {
    D9 ( "call" );
    if ( bnSplitPos->Record ) free ( bnSplitPos->Record );
                                     bnSplitPos->Record = NULL;
    memset ( bnSplitPos, 0x00, sizeof ( _bnSplitPos ) );
}//void bnSplitPosFree ( _bnSplitPos *bnSplitPos )


_bnSplitPos *bnSplitPosNext ( _bnSplitPos *bnSplitPos ) {
    D9 ( "call" );

    if ( ! bnSplitPos->Input    ) return NULL;
    if ( ! bnSplitPos->InputLen ) return NULL;

    if ( bnSplitPos->InputPos ) bnSplitPos->Beg = bnSplitPos->InputPos;

int          QuoteFlag  = 0;
_bnSplitPos *NextReturn = NULL;
    while ( bnSplitPos->InputPos <= bnSplitPos->InputLen ) {
	D9 ( "Input[%04ld]=%02d=~%c~", bnSplitPos->InputPos, bnSplitPos->Input[bnSplitPos->InputPos], bnSplitPos->Input[bnSplitPos->InputPos] );

	if ( bnSplitPos->Quote ) {
	    if ( QuoteFlag ) {
		if ( ( bnSplitPos->Quote[0] == bnSplitPos->Input[bnSplitPos->InputPos    ] ) &&
		     ( bnSplitPos->Quote[0] == bnSplitPos->Input[bnSplitPos->InputPos + 1] ) ) {
		    D9 ( "double Quote !!!" );
		    bnSplitPos->InputPos += 2;
		    continue;
		}
		else if ( ( '\\' == bnSplitPos->Input[bnSplitPos->InputPos    ] ) &&
		     ( bnSplitPos->Quote[0] == bnSplitPos->Input[bnSplitPos->InputPos + 1] ) ) {
		    D9 ( "double Quote !!!" );
		    bnSplitPos->InputPos += 2;
		    continue;
		}
	    }//if ( QuoteFlag )
	    if ( bnSplitPos->Quote[0] == bnSplitPos->Input[bnSplitPos->InputPos] ) {
		if ( ! QuoteFlag ) QuoteFlag = 1;
		else               QuoteFlag = 0;
	    }//if ( bnSplitPos->Quote[0] == bnSplitPos->Input[bnSplitPos->InputPos] )
	}//if ( Quote )
	D9 ( "QuoteFlag=%ld", QuoteFlag );

	if ( bnSplitPos->InputPos == bnSplitPos->InputLen ) NextReturn = bnSplitPos;
	if ( ( ! QuoteFlag ) && ( bnSplitPos->Delimiter == bnSplitPos->Input[bnSplitPos->InputPos] ) ) NextReturn = bnSplitPos;
	bnSplitPos->InputPos++; // !!! not return until here !!!
	if ( NextReturn ) {
	    bnSplitPos->Len  = bnSplitPos->InputPos - 1;//End
	    bnSplitPos->Len -= bnSplitPos->Beg;
	unsigned long SkipBeg= IgnoreBeg ( bnSplitPos->Input + bnSplitPos->Beg, bnSplitPos->Len, bnSplitPos->Ignore, bnSplitPos->IgnoreLen, bnSplitPos->Quote, bnSplitPos->DeQuote );
	    bnSplitPos->Beg += SkipBeg;
	    bnSplitPos->Len -= SkipBeg;
	    bnSplitPos->Len  = IgnoreEnd ( bnSplitPos->Input + bnSplitPos->Beg, bnSplitPos->Len, bnSplitPos->Ignore, bnSplitPos->IgnoreLen, bnSplitPos->Quote, bnSplitPos->DeQuote );
	    //2do rm if ( 0 > bnSplitPos->Len ) return NULL; unsigned long == never < 0
	    return NextReturn;
	}//if ( NextReturn )
    }//while ( bnSplitPos->InputPos <= bnSplitPos->InputLen )

    return NULL;

}//_bnSplitPos *bnSplitPosNext ( _bnSplitPos *bnSplitPos )


_bnSplitPos *bnSplitPosIndex ( _bnSplitPos *bnSplitPos ) {
    D9 ( "call" );
    if ( ! bnSplitPos ) return NULL;
#define RecordMAX 10000
	     bnSplitPos->Record = (_bnSplitPos *)malloc ( sizeof ( _bnSplitPos ) * RecordMAX );//2do realloc
    if ( !   bnSplitPos->Record ) return NULL;
    memset ( bnSplitPos->Record, 0x00, sizeof ( _bnSplitPos ) * RecordMAX );

    while ( bnSplitPosNext ( bnSplitPos ) ) {
    _bnSplitPos *spRecoRD = (_bnSplitPos *)bnSplitPos->Record;
    _bnSplitPos *spRecord = &spRecoRD[ bnSplitPos->Records ];
	bnSplitPos->Records++;
	if ( RecordMAX <= bnSplitPos->Records ) return NULL;

	D9 ( "spRecord=%p", spRecord );
	//bnSplitPosShow ( bnSplitPos );
	spRecord->Input = bnSplitPos->Input;
	spRecord->Beg   = bnSplitPos->Beg;
	spRecord->Len   = bnSplitPos->Len;
	//bnSplitPosShow ( spRecord );

    }//while ( bnSplitPosNext ( bnSplitPos ) )

    return bnSplitPos;

}//_bnSplitPos *bnSplitPosIndex ( _bnSplitPos *bnSplitPos )


char *bnSplitPosGet ( _bnSplitPos *bnSplitPos, unsigned long Fokus ) {
    D9 ( "call" );
    if ( RecordMAX <= bnSplitPos->Records ) return NULL;
    if ( Fokus     >  bnSplitPos->Records ) return NULL;

_bnSplitPos *spRecoRD = (_bnSplitPos *)bnSplitPos->Record;
_bnSplitPos *spRecord = &spRecoRD[ Fokus ];
    D9 ( "spRecord=%p", spRecord );
    //bnSplitPosShow ( spRecord );
    return strndup ( spRecord->Input + spRecord->Beg, spRecord->Len );
}//char *bnSplitPosGet ( _bnSplitPos *bnSplitPos, unsigned long Fokus )


void bnSplitPosTest ( void ) {
    D1 ( "call" );
char          *Input    = NULL;
unsigned long  InputLen =    0;

#define T1bnSplitPosTest
#ifdef  T1bnSplitPosTest
    Input    = (char *)"a,b,c";
    Input    = (char *)"	update bncsqlrsync set ChkSum='a;b'  ; select * from bncsqlrsync	";//sql syntax
    //Input    = (char *)",a,b,c";
    //Input    = (char *)", a ha	,,b,,c,,";
    //Input    = (char *)"\"a\\\"b\"";
    //Input    = (char *)"\"\\\"\\\"a\"\"\"\"b\\\"\\\"\"";
    //Input    = (char *)"\"a\nb\"";
    //Input    = (char *)"\"a	b\"	";
    //Input    = (char *)"   ab c   , \"a \\\"h_a !\"    ,,b,,c,,";
    //Input    = (char *)"   ab c   , \"a \"\"h,a !\"    ,";
    //Input    = (char *)"   ab c   , \"a h,a !\"    ,";
    //Input    = (char *)"   ab c   ";
    //Input    = (char *)"a    b";
    //Input    = (char *)"     ";
    //Input    = (char *)"     ,    ";
    InputLen = -1; //auto set in New
    //InputLen = 0; //OK
    //InputLen = 4; //OK
#endif

    D1 ( "Input=~%s~", Input );
_bnSplitPos *bnSplitPos = bnSplitPosNew ( Input, InputLen );
    //bnSplitPos->Quote  = NULL; //unset default
    //bnSplitPos->Ignore = NULL; //unset default
//sql syntax
    bnSplitPos->Delimiter = ';';
    bnSplitPos->Quote     = (char *)"\'";
    //bnSplitPos->Quote     = NULL;
    bnSplitPos->Ignore    = (char *)" 	\r";
    bnSplitPos->IgnoreLen = strlen ( bnSplitPos->Ignore );

    while ( bnSplitPosNext ( bnSplitPos ) ) {
	//bnSplitPosShow ( bnSplitPos );
    char          *Key    = strndup ( bnSplitPos->Input + bnSplitPos->Beg, bnSplitPos->Len );
    unsigned long  KeyLen = strlen ( Key );
	D1 ( "Key=~%s~", Key  );
	//KeyLen = DoubleQuoteDrop ( Key, KeyLen, bnSplitPos->Quote ); Key[KeyLen] = 0; D1 ( "Key=~%s~", Key  );
	//break; //bug4debug
    }//while ( bnSplitPosNext ( bnSplitPos ) )

    bnSplitPosFree ( bnSplitPos );

}//void bnSplitPosTest ( void )
