//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//2do AutoCreateDB
#include <bncsql.h>

#include <stdio.h>
#include <string>
#include <unistd.h>
#include <libgen.h> //4 dirname !!!
#include <sys/stat.h>

#ifdef bncSQLProxy_ENABLED
# include <bncSQLProxy.h>
#endif

#include <bnRC4.h>
#include <albus_log.h>
#ifndef bncSQLDataBase_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif



extern "C" {
#include "builtin/builtin.h"
}

//#include <link.h> // struct link_map
struct link_map {
    void *l_addr;   // Base address shared object is loaded at
    char *l_name;   // Absolute file name object was found in
    // ...          // Ignoring remaning parts of the structure
};

char bncSQLError[2048] = "";
_bncDataBase  dbDefault;


char *DriverNotLoad ( void *dummy ) {//2do mv 2 class 4 error
    fprintf ( stderr, "Error: DriverNotLoad !\n" ); fflush ( stdout );
    return NULL;
}//char *DriverNotLoad ( void *dummy )


void *_bncDataBase::Config ( int argc, char **argv ) {
    D9 ( "this=%p", this );

_bnRC4	bnRC;
	bnRC.Argc     = argc;
	bnRC.Argv     = argv;
	//RC.MustHave = "dbHost;dbBase;dbUser;dbPass;dbDriver"; 2do ??? enable
	bnRC.Open (); SIER ( bnRC.Error );
#ifdef bncSQL_DEBUG
	bnRC.Show ();
#endif

//ini DB
    if ( const char *GetVal = bnRC.GetVal ( "dbHost"              ) ) Host              = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbBase"              ) ) Base              = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbUser"              ) ) User              = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbPass"              ) ) Pass              = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbDriver"            ) ) Driver            = strdup ( GetVal );
//TLS
    if ( const char *GetVal = bnRC.GetVal ( "dbTLSCertificate"    ) ) TLSCertificate    = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbTLSPrivateKey"     ) ) TLSPrivateKey     = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbTLSPrivateKeyPass" ) ) TLSPrivateKeyPass = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbTLSFingerprint00"  ) ) TLSFingerprint00  = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbTLSFingerprint01"  ) ) TLSFingerprint01  = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbTLSFingerprint02"  ) ) TLSFingerprint02  = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbTLSFingerprint03"  ) ) TLSFingerprint03  = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbTLSFingerprint04"  ) ) TLSFingerprint04  = strdup ( GetVal );
//Paths
    if ( const char *GetVal = bnRC.GetVal ( "AppName"             ) ) {
	bn_free ( LibPath );
	          LibPath = strdup ( GetVal );
	dirname ( LibPath );
    }
    if ( const char *GetVal = bnRC.GetVal ( "dbLibPath"             ) ) {
	bn_free ( LibPath );
	          LibPath = strdup ( GetVal );
	dirname ( LibPath );
    }
    if ( const char *GetVal = bnRC.GetVal ( "dbHome"              ) ) Home              = strdup ( GetVal );
//albus_log
    if ( const char *GetVal = bnRC.GetVal ( "dbLogLevel"          ) ) albus_log_level   = atol   ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbLogSyslog"         ) ) albus_log_syslog  = atol   ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbLogStdio"          ) ) albus_log_stdio   = strdup ( GetVal );
    if ( const char *GetVal = bnRC.GetVal ( "dbLogFile"           ) ) albus_log_file    = strdup ( GetVal );

    return NULL;

}//void *_bncDataBase::Config ( int argc, char **argv )


void *_bncDataBase::Show ( void ) {
//2do VERSION...
    D2 ( "this             =%p"  , this              );
    D2 ( "            Error=~%s~", Error             );
    D2 ( "             Host=~%s~", Host              );
    D2 ( "             Port=%ld" , Port              );
    D2 ( "             Base=~%s~", Base              );
    D2 ( "             User=~%s~", User              );
#ifdef bncSQL_DEBUG
    D9 ( "             Pass=~%s~", Pass              );
#endif
    D2 ( "           Driver=~%s~", Driver            );
    D2 ( "       DriverName=~%s~", DriverName        );
    D2 ( "          Options=~%s~", Options           );
    D2 ( "            Quote=~%c~", Quote             );
    D2 ( "   TLSCertificate=~%s~", TLSCertificate    );
    D2 ( "    TLSPrivateKey=~%s~", TLSPrivateKey     );
#ifdef bncSQL_DEBUG
    D2 ( "TLSPrivateKeyPass=~%s~", TLSPrivateKeyPass );
#endif
    D2 ( " TLSFingerprint00=~%s~", TLSFingerprint00  );
    D2 ( " TLSFingerprint01=~%s~", TLSFingerprint01  );
    D2 ( " TLSFingerprint02=~%s~", TLSFingerprint02  );
    D2 ( " TLSFingerprint03=~%s~", TLSFingerprint03  );
    D2 ( " TLSFingerprint04=~%s~", TLSFingerprint04  );
    D2 ( "          LibPath=~%s~", LibPath           );
    D2 ( "             Home=~%s~", Home              );
    return NULL;
}//void *_bncDataBase::Show ( void )


void *_bncDataBase::DriverOpen ( void ) {
    D8 ( "this=%p", this );

//static bindings 2 driver
    BUILTIN_DRIVER

//error check
    if ( Error[0] ) return NULL;

//driver alredy open
    if ( Driver_API_Version ) return NULL;
    if ( DriverHandle       ) return NULL;//2do rm trigger

char XMod[255]      = "dummy";
    strcpy ( XMod, Driver );
    if ( strncmp ( Driver, "ODBC1.0:", strlen ("ODBC1.0:") ) == 0 ) strcpy ( XMod, "ODBC1.0" );

    for ( unsigned int xPos = 0; xPos < strlen ( XMod ); xPos++ ) {
	if ( '.' == XMod[xPos] ) { XMod[xPos] = '_'; }
    }

#ifdef WIN32
# define dlsym GetProcAddress
# define dlerror() "dlerror"
#endif

char dlsymName[255] = "";
//Driver_API_Version
    sprintf ( dlsymName, "%s_API_Version", XMod );
    Driver_API_Version = (long *)dlsym ( DriverHandle, dlsymName );
    //perror("dlsym");
    D9 ( "dlerror=%s\n", dlerror() );
    D9 ( "Driver_API_Version=%p", Driver_API_Version );
//Driver_API_Version done

    if ( ! Driver_API_Version ) {
    struct stat  Stat;
	memset ( &Stat, 0x00, sizeof ( struct stat ) );

    //Open Driver
	if ( LibPath ) {
	    D9 ( "LibPath=~%s~", LibPath );
    //2do PREFIX via LD_LIBRARY_PATH
#ifdef WIN32
	    if ( strncmp ( Driver, "ODBC1.0:", strlen ( "ODBC1.0:" ) ) == 0 ) sprintf ( DriverName, "%s\\libbncsql-%s.dll" , LibPath, "ODBC1.0" );
	    else                                                              sprintf ( DriverName, "%s\\libbncsql-%s.dll" , LibPath, Driver    );
#elif __APPLE__
	    if ( strncmp ( Driver, "ODBC1.0:", strlen ( "ODBC1.0:" ) ) == 0 ) sprintf ( DriverName, "%s/libbncsql-%s.dylib", LibPath, "ODBC1.0" );
	    else                                                              sprintf ( DriverName, "%s/libbncsql-%s.dylib", LibPath, Driver    );
#else
	    if ( strncmp ( Driver, "ODBC1.0:", strlen ( "ODBC1.0:" ) ) == 0 ) sprintf ( DriverName, "%s/libbncsql-%s.so"   , LibPath, "ODBC1.0" );
	    else                                                              sprintf ( DriverName, "%s/libbncsql-%s.so"   , LibPath, Driver    );
#endif
	    stat ( DriverName, &Stat );
	}//if ( LibPath )

	D8 ( "Stat.st_size=%ld", Stat.st_size );
	if ( ! Stat.st_size ) {
#ifdef WIN32
	    if ( strncmp ( Driver, "ODBC1.0:", strlen ( "ODBC1.0:" ) ) == 0 ) sprintf ( DriverName, "libbncsql-%s.dll"  , "ODBC1.0" );
	    else                                                              sprintf ( DriverName, "libbncsql-%s.dll"  , Driver    );
#elif __APPLE__
	    if ( strncmp ( Driver, "ODBC1.0:", strlen ( "ODBC1.0:" ) ) == 0 ) sprintf ( DriverName, "libbncsql-%s.dylib", "ODBC1.0" );
	    else                                                              sprintf ( DriverName, "libbncsql-%s.dylib", Driver    );
#else
	    if ( strncmp ( Driver, "ODBC1.0:", strlen ( "ODBC1.0:" ) ) == 0 ) sprintf ( DriverName, "libbncsql-%s.so"   , "ODBC1.0" );
	    else                                                              sprintf ( DriverName, "libbncsql-%s.so"   , Driver    );
#endif
	}//if ( ! Stat.st_size )

	D2 ( "DriverName=%s", DriverName );
#ifdef WIN32
	DriverHandle = LoadLibrary ( TEXT ( DriverName ) );
#else
	DriverHandle = dlopen ( DriverName, RTLD_NOW );
#endif

	if ( ! DriverHandle ) {
	    D1  ( "Builtin=%s", Builtin() );
	    SER ( "dlerror=%s\n", dlerror() );
	    return NULL;
	}//if ( ! DriverHandle )
    //Open Driver done

    //Driver_API_Version
	sprintf ( dlsymName, "%s_API_Version", XMod );
	Driver_API_Version = (long *)dlsym ( DriverHandle, dlsymName );

    }//if ( ! Driver_API_Version )

    if ( ! Driver_API_Version ) SER ( "! Driver_API_Version" );
    D9 ( "*Driver_API_Version=%ld", *Driver_API_Version );
    if ( (long)bncSQL_API_VERSION != *Driver_API_Version ) SER ( "bncSQL_API_VERSION=0x%02X != *Driver_API_Version=0x%02X", (long)bncSQL_API_VERSION, *Driver_API_Version );
//Driver_API_Version done

//Driver_Version
    sprintf ( dlsymName, "%s_Version", XMod );
    Driver_Version = (char *)dlsym ( DriverHandle, dlsymName );
    if ( ! Driver_Version ) SER ( "! Driver_Version" );
    D9 ( "Driver_Version=~%s~", Driver_Version );
//Driver_Version done

//Link Driver Function						dbOpen
    sprintf ( dlsymName, "%s_dbOpen", XMod );
    *(void **)(&dbOpen) = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  dbOpen) {
    *(void **)(&dbOpen) = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//Link Driver Function						dbClose
    sprintf ( dlsymName, "%s_dbClose", XMod );
    *(void **)(&dbClose) = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  dbClose) {
    *(void **)(&dbClose) = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//Link Driver Function						tbOpen
    sprintf ( dlsymName, "%s_tbOpen", XMod );
    *(void **)(&tbOpen) = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  tbOpen) {
    *(void **)(&tbOpen) = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//Link Driver Function						tbColumn
    sprintf ( dlsymName, "%s_tbColumnInsert", XMod );
    *(void **)(&tbColumnInsert) = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  tbColumnInsert) {
    *(void **)(&tbColumnInsert) = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//Link Driver Function						tbClose
    sprintf ( dlsymName, "%s_tbClose", XMod );
    *(void **)(&tbClose) = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  tbClose) {
    *(void **)(&tbClose) = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//Link Driver Function						tbRecord
    sprintf ( dlsymName, "%s_tbRecord", XMod );
    *(void **)(&tbRecord)  = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  tbRecord) {
    *(void **)(&tbRecord)  = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//Link Driver Function						tbColumn
    sprintf ( dlsymName, "%s_tbColumn", XMod );
    *(void **)(&tbColumn)  = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  tbColumn) {
    *(void **)(&tbColumn)  = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//Link Driver Function						tbSQLBuild
    sprintf ( dlsymName, "%s_tbSQLBuild", XMod );
    *(void **)(&tbSQLBuild)  = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  tbSQLBuild) {
    *(void **)(&tbSQLBuild)  = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//Link Driver Function						coDEF
    sprintf ( dlsymName, "%s_coDEF", XMod );
    *(void **)(&coDEF)  = (void **)dlsym ( DriverHandle, dlsymName );
    if (     !  coDEF) {
    *(void **)(&coDEF)  = (void *)&DriverNotLoad;
	SER ( "dlerror=%s\n", dlerror() );
    }
//albus_log
int	  *albus_log_level_drv = 0;
	   albus_log_level_drv =   (int *)dlsym ( DriverHandle, "albus_log_level" );
    if (   albus_log_level_drv ) *albus_log_level_drv = albus_log_level;
char	 **albus_log_stdio_drv = NULL;
	   albus_log_stdio_drv = (char **)dlsym ( DriverHandle, "albus_log_stdio" );
    if (   albus_log_stdio_drv ) *albus_log_stdio_drv = albus_log_stdio;

//driver path info
char RealPWD[2048] = "";
    getcwd ( RealPWD, 2047 );
char dlinfoPathName[2048] = "";
const struct link_map* link_map = 0;
#ifdef __APPLE__
    link_map = static_cast<const struct link_map*>(DriverHandle);
#endif
#ifdef __linux__
# ifndef __ANDROID__
    link_map = static_cast<const struct link_map*>(DriverHandle);
# endif
#endif
    D9 ( "link_map=%p", link_map );
    if ( link_map ) {
	D9 ( "l_name=%s", link_map->l_name );
	strcpy ( dlinfoPathName, link_map->l_name );
    }
    //int  dlinfoRX = dlinfo ( DriverHandle, RTLD_DI_ORIGIN, (void *)&dlinfoPathName );//linux only
    D2 ( "DriverName=%s Version=%s RealPWD=%s, dlinfoPathName=%s", DriverName, Driver_Version, RealPWD, dlinfoPathName );

    return NULL;

}//void *_bncDataBase::DriverOpen ( void )


void *_bncDataBase::DriverClose ( void ) {
    D8 ( "this=%p", this );

//Handle close
    if ( DriverHandle ) {
	D8 ( "DriverName=%s", DriverName );
#ifdef WIN32
	FreeLibrary ( DriverHandle );
#else
	dlclose ( DriverHandle );
#endif
	DriverHandle = NULL;
    }//if ( DriverHandle )

//UnLink Driver
    *(void **)(&dbOpen)         = (void *)&DriverNotLoad;
    *(void **)(&dbClose)        = (void *)&DriverNotLoad;
    *(void **)(&tbOpen)         = (void *)&DriverNotLoad;
    *(void **)(&tbColumnInsert) = (void *)&DriverNotLoad;
    *(void **)(&tbClose)        = (void *)&DriverNotLoad;
    *(void **)(&tbRecord)       = (void *)&DriverNotLoad;
    *(void **)(&tbColumn)       = (void *)&DriverNotLoad;
    *(void **)(&tbSQLBuild)     = (void *)&DriverNotLoad;
    *(void **)(&coDEF)          = (void *)&DriverNotLoad;

    return NULL;

}//void *_bncDataBase::DriverClose ( void )


char *_bncDataBase::Builtin ( void ) { return (char *)BUILTIN_HAVE; }


void *_bncDataBase::Open ( void ) {
    D8 ( "this=%p", this );

//error check
    if (   Error[0]  ) return NULL;
    if ( ! Driver    ) SER ( "! Driver"    );
    if ( ! Driver[0] ) SER ( "! Driver[0]" );

    D4 ( "NAME=~%s~ VERSION=~%s~ PREFIX=~%s~ PLATFORM=~%s~ BUILD_DATE_TIME=~%s~", PACKAGE_NAME, LIBBNCSQL_VERSION, PREFIX, PLATFORM, BUILD_DATE_TIME );

#ifdef bncSQLProxy_ENABLED
//bncSQLProxy
    if ( ! bncSQLProxyVP ) bncSQLProxyVP = new _bncSQLProxy;
_bncSQLProxy *bncSQLProxy = (_bncSQLProxy *)bncSQLProxyVP;
    if ( ( Host ) && ( 5 < strlen ( Host ) ) && ( strncmp ( Host, "http", strlen ( "http" ) ) == 0 ) && ( ! bncSQLProxy->LocalPort ) ) {

	D9 ( "Home=%s", Home );
	D9 ( "TLSCertificate=%s", TLSCertificate );
	D9 ( "TLSPrivateKey =%s", TLSPrivateKey  );
	if ( Home ) {//2do @ bncSQLProxy
	char myBuffer[1024];
	    if ( TLSCertificate ) {
		if ( ( strncmp ( TLSCertificate, "-----BEGIN", strlen ( "-----BEGIN" ) ) != 0 ) ) {
		    sprintf ( myBuffer, "%s/%s", Home, TLSCertificate ); //2do if ! ^/
		    bn_free ( TLSCertificate );
		    TLSCertificate = strdup ( myBuffer );
		}
	    }//if ( tb->db->TLSCertificate )
	    if ( TLSPrivateKey ) {
		if ( ( strncmp ( TLSPrivateKey, "-----BEGIN", strlen ( "-----BEGIN" ) ) != 0 ) ) {
		    sprintf ( myBuffer, "%s/%s", Home, TLSPrivateKey ); //2do if ! ^/
		    bn_free ( TLSPrivateKey );
		    TLSPrivateKey = strdup ( myBuffer );
		}
	    }//if ( tb->db->TLSPrivateKey )
	}//if ( Home )
	D9 ( "TLSCertificate=%s", TLSCertificate );
	D9 ( "TLSPrivateKey =%s", TLSPrivateKey  );

    //Remote
	if ( Host              ) bncSQLProxy->RemoteHost              = strdup ( Host              );
	if ( TLSCertificate    ) bncSQLProxy->RemoteTLSCertificate    = strdup ( TLSCertificate    );
	if ( TLSPrivateKey     ) bncSQLProxy->RemoteTLSPrivateKey     = strdup ( TLSPrivateKey     );
	if ( TLSPrivateKeyPass ) bncSQLProxy->RemoteTLSPrivateKeyPass = strdup ( TLSPrivateKeyPass );
	if ( TLSFingerprint00  ) bncSQLProxy->RemoteTLSFingerprint00  = strdup ( TLSFingerprint00  );
	if ( TLSFingerprint01  ) bncSQLProxy->RemoteTLSFingerprint01  = strdup ( TLSFingerprint01  );
	if ( TLSFingerprint02  ) bncSQLProxy->RemoteTLSFingerprint02  = strdup ( TLSFingerprint02  );
	if ( TLSFingerprint03  ) bncSQLProxy->RemoteTLSFingerprint03  = strdup ( TLSFingerprint03  );
	if ( TLSFingerprint04  ) bncSQLProxy->RemoteTLSFingerprint04  = strdup ( TLSFingerprint04  );

    //Local
	bn_free ( Host );
	          Port = 0;
	bncSQLProxy->LocalHost    = strdup ( "127.0.0.1" );
	bncSQLProxy->LocalPort    = 0;
	bncSQLProxy->Agent        = strdup ( "bncsql"    );
	bncSQLProxy->AgentVersion = strdup ( "1.0.0"     );
	bncSQLProxy->Driver       = strdup ( Driver      );
	bncSQLProxy->Open   ();
	if ( bncSQLProxy->Error[0] ) SER ( bncSQLProxy->Error );
	D2 ( "LocalHost=%s:%ld", bncSQLProxy->LocalHost, bncSQLProxy->LocalPort );
	Host = strdup ( bncSQLProxy->LocalHost );
	Port =          bncSQLProxy->LocalPort  ;
    }//if ( ( Host ) && ( 5 < strlen ( Host ) ) && ( strncmp ( Host, "http", strlen ( "http" ) ) == 0 ) && ( ! bncSQLProxy->LocalPort ) )
//bncSQLProxy done
#endif
    D2 ("Host=%s:%ld", Host, Port );

    DriverOpen ();
    if ( Error[0] ) return NULL;

//Open DataBase via Driver
    (*dbOpen)( this );

    return NULL;

}//void *_bncDataBase::Open ( void )


void *_bncDataBase::Destructor ( void ) {
    D8 ( "this=%p", this );

//2do close all tables, new table->stack

//Close DataBase via Driver
    if ( DriverHandle ) (*dbClose)( this );
    DriverClose ();
#ifdef bncSQLProxy_ENABLED
_bncSQLProxy *bncSQLProxy = (_bncSQLProxy *)bncSQLProxyVP;
    if ( bncSQLProxy ) delete bncSQLProxy;
                              bncSQLProxy   = NULL;
                              bncSQLProxyVP = NULL;
#endif
//all OK
    Error[0] = 0;

    return NULL;

}//void *_bncDataBase::Destructor ( void )
