//Copyright 2017-2018 blacknoise.at
//
//   You may use this file WITHOUT CHANGES according to Apache License, Version 2.0.
//   Modifications of this file is NOT allowed without prior written permission.
//   For written permission, please contact us via http://www.blacknoise.at/?Contact
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//
//#define bncSQLRSync_DEBUG
#ifdef HAVE_CONFIG
# include <config.h>
#endif
#ifdef bncSQLRSync_ENABLED
#include "bnplugin_crt.h"

#ifdef DEBUG
# define bncSQLRSync_DEBUG
#endif

//template echo "bncsql certificate create 'fileout.crt','aaa=xxx;bbb=yyy;subjectAltName=DNS:testbncsql.blacknoise.at,DNS:dummy.blacknoise.at;product-key=xxxxx.yyyyy.zzzzz',1" | ./bncsql
//FS=":,=" used in openssl
//FS=";"
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <libgen.h> //4 dirname/basename !!!
#include <json-c/json.h>

#include <bncsql.h>
#include <base64.h>

//#define bnSSL_ENABLED
#include <bnSSL.h>

#include <bnDir.h>

#include <bnSplitPos.h>
#include <albus_log.h>
#ifndef bncSQLRSync_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif


long FindNameType ( _bncTable *tb, char *Name, char *Type ) {
    D9 ( "tb=%p, Name=%s, Type=%s", tb, Name, Type );
    if ( tb->Result ) {
    _bncTable **tbs = (_bncTable **)tb->Result;
	for ( unsigned long RecordsPos = 0; RecordsPos < tb->Records; RecordsPos++ ) {
	_bncTable *tbSrc = tbs[RecordsPos];
	    D9 ( "tbSrc=%p", tbSrc );
	    if ( strcmp ( (*(*tbSrc)["Name"]).GetChar(), Name ) != 0 ) continue;
	    if ( strcmp ( (*(*tbSrc)["Type"]).GetChar(), Type ) != 0 ) continue;
	    D9 ( "Match RecordsPos=%ld", RecordsPos );
	    return RecordsPos;
	}//for ( unsigned long RecordsPos = 0; RecordsPos < tb->Records; RecordsPos++ )
    }//if ( tb->Result )
    return -1;
}//long FindNameType ( _bncTable *tb, char *Name, char *Type )


class _bncsqlrsync {
public:
    _bncTable *tb;
    long long  ID;
         char  Name[255];
         char  Version[255];
         char  Type[255];
         long  USec;
         long  Size;
         char  WhereKey[255];
         char  ChkSum[255];
         char  Kernel[255];
         char  Memo[255];
         long  Flag;
unsigned char *PayLoad;
unsigned long  PayLoadLen;
unsigned char *Image;
unsigned long  ImageLen;

    _bncsqlrsync() {
        memset ( this, 0x00, sizeof ( _bncsqlrsync ) );
        tb       = new _bncTable;
        tb->Name = strdup ( "bncsqlrsync" );
//      tb->ColumnInsert (             "Image",               Image,    0,           &ImageLen,    NULL, bn_blob      );
        tb->ColumnInsert (              "Name",               &Name,  255,                NULL,    NULL, bn_char      );
        tb->ColumnInsert (              "USec",               &USec,    0,                NULL,    NULL, bn_long      );
        tb->ColumnInsert (           "Version",            &Version,  255,                NULL,    NULL, bn_char      );
        tb->ColumnInsert (              "Type",               &Type,  255,                NULL,    NULL, bn_char      );
        tb->ColumnInsert (          "WhereKey",           &WhereKey,  255,                NULL,    NULL, bn_char      );
//      tb->ColumnInsert (            "ChkSum",             &ChkSum,  255,                NULL,    NULL, bn_char      );
//      tb->ColumnInsert (                "ID",                 &ID,    0,                NULL,    NULL, bn_long_long + bn_AUTO_INCREMENT + bn_PRI_KEY );
//      tb->ColumnInsert (              "Size",               &Size,    0,                NULL,    NULL, bn_long      );
//      tb->ColumnInsert (            "Kernel",             &Kernel,  255,                NULL,    NULL, bn_char      );
//      tb->ColumnInsert (              "Memo",               &Memo,  255,                NULL,    NULL, bn_char      );
//      tb->ColumnInsert (              "Flag",               &Flag,    0,                NULL,    NULL, bn_long      );
//      tb->ColumnInsert (           "PayLoad",             PayLoad,    0,         &PayLoadLen,    NULL, bn_blob      );
    }

    ~_bncsqlrsync() {
        bn_free (             PayLoad );        bn_free (               Image );
        delete tb;
    }

};


void *bncSQLApplicationShow ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
//error check
    if ( tb->Error[0] ) return NULL;

_bncsqlrsync bncsqlrsync;
std::string  WhereKey;
char        *Query      = NULL;
_bnSplitPos *spQuery    = NULL;
char        *ShowPath   = NULL;
long         ShowUpdate =    0;
_bnDir       diCrt;
_bnDir       diApp;
_bnDir       diSQL;
_bncTable   *tbDst      = NULL;
_bncTable  **tbs        = NULL;
long         tbsRecords =    0;
long         tbsPos     =    0;
_bncDataBase dbSrc;
_bncTable    tbSrc;

    if ( ! tb ) SEGT ( "! tb" );
    D9 ( "tb->Query=~%s~", tb->Query );

    if ( strlen  ( tb->Query ) <= strlen ( "bncsql application show " ) ) SEGT ( "Query too short" );
    if ( strncmp ( tb->Query, "bncsql application show ",strlen ( "bncsql application show " ) ) == 0 ) Query = strdup ( tb->Query + strlen ( "bncsql application show " ) );
    else SEGT ( "! crt string" );

    D9 ( "Query=~%s~", Query );

    spQuery = bnSplitPosNew ( Query, -1 );
    spQuery->Delimiter = ',';
    spQuery->Quote     = (char *)"\'";
    bnSplitPosIndex ( spQuery );
    D9 ( "spQuery->Records=%ld", spQuery->Records );
    if ( 2 > spQuery->Records ) SEGT ( "2 > spQuery->Records=%ld", spQuery->Records );

    ShowPath   =        bnSplitPosGet ( spQuery, 0 )  ;
    ShowUpdate = atol ( bnSplitPosGet ( spQuery, 1 ) );
    D9 ( "ShowPath   =~%s~ ShowUpdate=%ld", ShowPath, ShowUpdate );

    if ( ShowUpdate ) {

	diCrt.Path     = strdup ( ShowPath );
	diCrt.Name     = strdup ( "*.crt" );
	diCrt.Recursiv = 0;
	while ( _bnDir *diCrtNext = diCrt.Next () ) {
	    D9 ( "Include=%02d PathName[%03ld]=~%s~", diCrtNext->Include, diCrt.Fokus, diCrtNext->PathName );
	char *Fingerprint = bnSSLFingerprint ( diCrtNext->PathName, "sha256" );
	    if ( ! Fingerprint ) SEGT ( "! Fingerprint" );
	    D9 ( "Fingerprint=~%s~ PathName=~%s~", Fingerprint, diCrtNext->PathName );
	    if ( WhereKey.size () ) WhereKey += ",";
	    WhereKey += "'";
	    WhereKey += Fingerprint;
	    WhereKey += "'";
	    //diCrtNext->Show ();
	    //break;//bug4debug
	}//while ( _bnDir *diCrtNext = diCrt.Next () )
	if ( diCrt.Error[0] ) SEGT ( "%s", diCrt.Error );
	D9 ( "diCrt.Records=%ld", diCrt.Records );
	D1 ( "WhereKey=~%s~", WhereKey.c_str () );

	dbSrc.Host           = strdup ( bncSQLRSyncHost           );
	dbSrc.Base           = strdup ( bncSQLRSyncBase           );
	dbSrc.User           = strdup ( bncSQLRSyncUser           );
	dbSrc.Pass           = strdup ( bncSQLRSyncPass           );
	dbSrc.Driver         = strdup ( bncSQLRSyncDriver         );
	dbSrc.TLSCertificate = strdup ( bncSQLRSyncTLSCertificate );
	dbSrc.TLSPrivateKey  = strdup ( bncSQLRSyncTLSPrivateKey  );
	//2do TLSFingerprint00 ???
	if ( tb->db ) {
	    if ( tb->db->Home    ) dbSrc.Home    = strdup ( tb->db->Home    );
	    if ( tb->db->LibPath ) dbSrc.LibPath = strdup ( tb->db->LibPath );
	}
	//dbSrc.Show ();//bug4debug
	tbSrc.db = &dbSrc;

    //if no WhereKey
	if ( "" != WhereKey ) {
	    tbSrc.SQLQuery ( "select Image,USec,Name,Version,Type,WhereKey,ChkSum from bncsqlrsync where Type in ('bncbin','bncsql') and WhereKey in (%s)", WhereKey.c_str () );
	    tbSrc.First ();
	    if ( tbSrc.Error[0] ) SEGT ( "%s", tbSrc.Error );
	    D9 ( "tbSrc.Records=%ld", tbSrc.Records );
	    tbsRecords += tbSrc.Records;
	}//if ( "" != WhereKey )

    }//if ( ShowUpdate )

    diApp.Path     = strdup ( ShowPath );
    diApp.Name     = strdup ( "*.bncbin" );
    diApp.Recursiv = 0;
    diApp.Open ();
    if ( diApp.Error[0] ) SEGT ( "%s", diApp.Error );
    D9 ( "diApp.Records=%ld", diApp.Records );
    tbsRecords += diApp.Records;

    diSQL.Path     = strdup ( ShowPath );
    diSQL.Name     = strdup ( "*.bncsql" );
    diSQL.Recursiv = 0;
    diSQL.Open ();
    if ( diSQL.Error[0] ) SEGT ( "%s", diSQL.Error );
    tbsRecords += diSQL.Records;
    D9 ( "diSQL.Records=%ld", diSQL.Records );

    D9 ( "tbsRecords=%ld", tbsRecords );
    tbs = (_bncTable **)malloc( sizeof (_bncTable *) * (tbsRecords + 1) ); //free = done via bncsql_tbClose
    if ( ! tbs ) SEGT ( "! tbs" );
    memset (  tbs, 0x00       , sizeof (_bncTable *) * (tbsRecords + 1) );
    tb->Result = tbs;

    tbDst = tbs[0];
    if ( ! tbDst ) {
	D9 ( "tbDst = new _bncTable" );
	tbDst = new _bncTable;
	tbDst->ColumnInsert ( bncsqlrsync.tb );
	tbs[0] = tbDst;
    }//if ( ! tbDst )
    tbDst = tbs[0];
    if ( ! tbDst ) SEGT ( "! tbDst" );

//remote App
    if ( ( ShowUpdate == 1 ) && ( tbSrc.Records ) ) {
	tbSrc.Fokus = 0;
	while ( tbSrc.Next () ) {
	    D9 ( "tbSrc.Fokus=%ld", tbSrc.Fokus );
	    //tbSrc.Show ();//bug4debug
	    tbsPos = FindNameType ( tb, (*(tbSrc)["Name"]).GetChar(), (*(tbSrc)["Type"]).GetChar() );
	    //tbsPos = -1; //bug4debug
	    if ( 0 > tbsPos ) {
		tbsPos = tb->Records;
	//amount of Records
		tb->Records++;
	    }
	    tbDst = tbs[tbsPos];
	    if ( ! tbDst ) {
		D9 ( "tbDst = new _bncTable" );
		tbDst = new _bncTable;
		tbDst->ColumnInsert ( bncsqlrsync.tb );
		tbs[tbsPos] = tbDst;
	    }//if ( ! tbDst )
	    tbDst = tbs[tbsPos];
	    if ( ! tbDst ) SEGT ( "! tbDst" );
	    tbDst->Set ( &tbSrc );
	    //tbDst->Records = 1; tbDst->Show ();//bug4debug
	    //break;//bug4debug
	}//while ( tbSrc.Next () )
	if ( tbSrc.Error[0] ) SEGT ( "           %s", tbSrc.Error );
    }//if ( ( ShowUpdate == 1 ) && ( tbSrc.Records ) )
//remote App done

//local Profiles
    while ( _bnDir *diSQLNext = diSQL.Next () ) {
//2do rm if ( strcmp ( "default.bncsql", diSQLNext->Name ) == 0 ) continue;
	D9 ( "Include=%02d PathName[%03ld]=~%s~", diSQLNext->Include, diSQL.Fokus, diSQLNext->PathName );
    char Name[1024] = "";
	strcpy ( Name, diSQLNext->Name );
	Name[ strlen ( Name ) - 7 ] = 0;
	tbsPos = FindNameType ( tb, Name, (char *)"bncsql" );
	//tbsPos = -1; //bug4debug
	if ( 0 > tbsPos ) {
	    tbsPos = tb->Records;
    //amount of Records
	    tb->Records++;
	}
	tbDst = tbs[tbsPos];
	if ( ! tbDst ) {
	    D9 ( "tbDst = new _bncTable" );
	    tbDst = new _bncTable;
	    tbDst->ColumnInsert ( bncsqlrsync.tb );
	    tbs[tbsPos] = tbDst;
	}//if ( ! tbDst )
	tbDst = tbs[tbsPos];
	if ( ! tbDst ) SEGT ( "! tbDst" );
	(*(*tbDst)["Name"       ]).SetChar ( (const unsigned char *)Name     );
	(*(*tbDst)["Type"       ]).SetChar ( (const unsigned char *)"bncsql" );
    _bncColumn *coUSec = (*tbDst)["USec"];
	if ( ! coUSec ) SEGT ( "! coUSec" );
	       coUSec->Type &= ~bn_IS_NULL; //unset NULL
    long *reUSec = coUSec->GetLong ();
	if ( ! reUSec   ) SEGT ( "! reUSec"   );
	*reUSec = 0;//no update
	//diSQLNext->Show ();
	//break;//bug4debug
    }//while ( _bnDir *diSQLNext = diSQL.Next () )
    if ( diSQL.Error[0] ) SEGT ( "%s", diSQL.Error );
//local Profiles done

//local Apps
    while ( _bnDir *diAppNext = diApp.Next () ) {
	D9 ( "Include=%02d PathName[%03ld]=~%s~", diAppNext->Include, diApp.Fokus, diAppNext->PathName );
    char Name[1024] = "";
	strcpy ( Name, diAppNext->Name );
	Name[ strlen ( Name ) - 7 ] = 0;
	tbsPos = FindNameType ( tb, Name, (char *)"bncbin" );
	//tbsPos = -1; //bug4debug
	if ( 0 > tbsPos ) {
	    tbsPos = tb->Records;
    //amount of Records
	    tb->Records++;
	}
	tbDst = tbs[tbsPos];
	if ( ! tbDst ) {
	    D9 ( "tbDst = new _bncTable" );
	    tbDst = new _bncTable;
	    tbDst->ColumnInsert ( bncsqlrsync.tb );
	    tbs[tbsPos] = tbDst;
	}//if ( ! tbDst )
	tbDst = tbs[tbsPos];
	if ( ! tbDst ) SEGT ( "! tbDst" );
    long loUSec = 0;
    _bnBlob blApp;
	blApp.FileRead ( diAppNext->PathName );
	//blApp.Show ( "blApp" ); //bug4debug
    json_object *jo_rx = json_tokener_parse ( (char *)blApp.data );
	if ( jo_rx ) {
	json_object *obj_name = json_object_object_get ( jo_rx, (const char *)"MTime" );
	    if ( obj_name ) { loUSec = json_object_get_int ( obj_name ); }
	}
	D1 ( "loUSec=%ld", loUSec );
    _bncColumn *coUSec = (*tbDst)["USec"];
	if ( ! coUSec ) SEGT ( "! coUSec" );
	       coUSec->Type &= ~bn_IS_NULL; //unset NULL
    long *reUSec = coUSec->GetLong ();
	if ( ! reUSec   ) SEGT ( "! reUSec"   );
	if ( *reUSec <= loUSec ) *reUSec = 0;//no update
	(*(*tbDst)["Name"       ]).SetChar ( (const unsigned char *)Name     );
	(*(*tbDst)["Type"       ]).SetChar ( (const unsigned char *)"bncbin" );
	//diAppNext->Show ();
	//break;//bug4debug
    }//while ( _bnDir *diAppNext = diApp.Next () )
    if ( diApp.Error[0] ) SEGT ( "%s", diApp.Error );
//local Apps done

//amount of Fields
    tb->ColumnFetchDone = 1;//map direct to tb->columns
    tbDst = tbs[0];
    tb->Fields = 0;
    while ( _bncColumn *Column = (*tbDst)[tb->Fields++] ) {}
    tb->Fields--;

    D1 ( "tb->Fields =%ld", tb->Fields  );
    D1 ( "tb->Records=%ld", tb->Records );

my_return:
    tbSrc.db = NULL; //else crash @ ios, android
    bn_free ( Query    );
    bn_free ( ShowPath );
    if ( spQuery ) bnSplitPosFree ( spQuery );

    return NULL;

}//void *bncSQLApplicationShow ( _bncTable *tb )


void *bncSQLApplicationDownload ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
//error check
    if ( tb->Error[0] ) return NULL;

char          *Query            = NULL;
_bnSplitPos   *spQuery          = NULL;
char          *DownloadPath     = NULL;
char          *DownloadName     = NULL;
char          *DownloadType     = NULL;
char          *DownloadWhereKey = NULL;
_bnBlob        blPayLoad;
unsigned char *PayLoad2         = NULL;
unsigned long  PayLoadLen       = 0;
unsigned long  blob_len;
unsigned char *blob_data;
_bncColumn    *coPayLoad        = NULL;
_bncDataBase   dbSrc;
_bncTable     *tbDst            = NULL;
char          *ClientKey        = NULL;
char          *Bin              = NULL;

    if ( ! tb ) SEGT ( "! tb" );
    D9 ( "tb->Query=~%s~", tb->Query );

    if ( strlen  ( tb->Query ) <= strlen ( "bncsql application download " ) ) SEGT ( "Query too short" );
    if ( strncmp ( tb->Query, "bncsql application download ",strlen ( "bncsql application download " ) ) == 0 ) Query = strdup ( tb->Query + strlen ( "bncsql application download " ) );
    else SEGT ( "! crt string" );

    D9 ( "Query=~%s~", Query );

    spQuery = bnSplitPosNew ( Query, -1 );
    spQuery->Delimiter = ',';
    spQuery->Quote     = (char *)"\'";
    bnSplitPosIndex ( spQuery );
    D9 ( "spQuery->Records=%ld", spQuery->Records );
    if ( 4 > spQuery->Records ) SEGT ( "4 > spQuery->Records=%ld", spQuery->Records );

    DownloadPath       = bnSplitPosGet ( spQuery, 0 )  ;
    D9 ( "DownloadPath     =~%s~", DownloadPath );

    DownloadName       = bnSplitPosGet ( spQuery, 1 )  ;
    D9 ( "DownloadName     =~%s~", DownloadName );

    DownloadType       = bnSplitPosGet ( spQuery, 2 )  ;
    D9 ( "DownloadType     =~%s~", DownloadType );

    DownloadWhereKey   = bnSplitPosGet ( spQuery, 3 )  ;
    D9 ( "DownloadWhereKey =~%s~", DownloadWhereKey );

    dbSrc.Host           = strdup ( bncSQLRSyncHost           );
    dbSrc.Base           = strdup ( bncSQLRSyncBase           );
    dbSrc.User           = strdup ( bncSQLRSyncUser           );
    dbSrc.Pass           = strdup ( bncSQLRSyncPass           );
    dbSrc.Driver         = strdup ( bncSQLRSyncDriver         );
    dbSrc.TLSCertificate = strdup ( bncSQLRSyncTLSCertificate );
    dbSrc.TLSPrivateKey  = strdup ( bncSQLRSyncTLSPrivateKey  );
    //2do TLSFingerprint00 ???
    if ( tb->db ) {
	if ( tb->db->Home    ) dbSrc.Home    = strdup ( tb->db->Home    );
	if ( tb->db->LibPath ) dbSrc.LibPath = strdup ( tb->db->LibPath );
    }
    //dbSrc.Show ();//bug4debug

    tbDst = new _bncTable;
    tbDst->db = &dbSrc;
    tbDst->ColumnInsert (           "PayLoad",             PayLoad2,    0,         &PayLoadLen,    NULL, bn_blob      );
    tbDst->SQLQuery ( "select PayLoad from bncsqlrsync where Name='%s' and Type='%s' and WhereKey='%s'", DownloadName, DownloadType, DownloadWhereKey );
    tbDst->First ();
    if ( tbDst->Error[0] ) SEGT ( "%s", tbDst->Error );
    if ( 1 != tbDst->Records ) SEGT ( "1 != tbDst->Records=%ld", tbDst->Records );

    tbDst->Show ();

    coPayLoad = (*tbDst)["PayLoad"];
    if ( ! coPayLoad ) SEGT ( "! coPayLoad" );

    coPayLoad->GetBlob ( &blob_data, &blob_len );

    D9 ( "blob_data=%p" , blob_data );
    D9 ( "blob_len =%ld", blob_len  );
    if ( ! blob_data ) SEGT ( "! blob_data" );
    if ( ! blob_len  ) SEGT ( "! blob_len"  );

    //bug2, write 2 tmp, check ChkSum, -> mv
//if ( ! PayLoadLen ) SEGT ( "! PayLoadLen" );
    D9 ( "PayLoad2  =%p" , PayLoad2   ); //bug2 @ bn_blob, no binding 2 PayLoad2
    D9 ( "PayLoadLen=%ld", PayLoadLen );
    blPayLoad.data = blob_data;
    blPayLoad.len  = blob_len;
    blPayLoad.Show ( "blPayLoad" );
    if ( strcmp ( DownloadType, "bncsql" ) == 0 ) {
    //blPayLoad decode

    json_object *jo_rx = json_tokener_parse ( (char *)blPayLoad.data );
	if ( jo_rx ) {
	json_object *obj_name = json_object_object_get ( jo_rx, (const char *)"ClientKey" );
	    if ( obj_name ) { ClientKey = strdup ( json_object_get_string ( obj_name ) ); }
	json_object *obj_bin  = json_object_object_get ( jo_rx, (const char *)"bin"       );
	    if ( obj_bin  ) { Bin       = strdup ( json_object_get_string ( obj_bin  ) ); }
	}
	if ( ! ClientKey ) SEGT ( "! ClientKey" );//bug2 crash @ SEGT
	if ( strcmp ( ".crt", ClientKey + strlen ( ClientKey ) - 4 ) == 0 ) ClientKey[strlen(ClientKey)-4] = 0;
	D1 ( "ClientKey=%s", ClientKey );

	if ( ! Bin    ) SEGT ( "! Bin"    );
	if ( ! Bin[0] ) SEGT ( "! Bin[0]" );
	D1 ( "Bin=%s", Bin );

//#define bnplugin_py_DEBUG
    _bnBlob    blSignKey ( (unsigned long)0 );
	       blSignKey.FileRead ( "%s.key", ClientKey );
	if ( ! blSignKey.len ) SER ( "file %s.key not found", ClientKey ); //2do SEGT
#ifdef bnplugin_py_DEBUG
	       blSignKey.Show ( "blSignKey" );
#endif

    _bnBlob    blDataCrt ( (unsigned long)0 );
	       blDataCrt.Append ( bnplugin_crt );
	if ( ! blDataCrt.len ) SER ( "! blDataCrt.len" );
#ifdef bnplugin_py_DEBUG
	       blDataCrt.Show ( "blDataCrt" );
#endif

    _bnBlob blBin;
	    blBin.Append ( Bin );
#ifdef bnplugin_py_DEBUG
	    blBin.Show      ( "%s.0.blBin.bin", "/tmp/Plugin" );
	    blBin.FileWrite ( "%s.0.blBin.bin", "/tmp/Plugin" );
#endif

    _bnBlob   *blSign = bnSSLDecrypt ( &blBin, &blDataCrt, NULL, 1 );
	if ( ! blSign->data ) SER ( "blSign->data" );
#ifdef bnplugin_py_DEBUG
	       blSign->Show      ( "%s.1.blSign.bin", "/tmp/Plugin" );
	       blSign->FileWrite ( "%s.1.blSign.bin", "/tmp/Plugin" );
#endif

    _bnBlob   *blData = bnSSLDecrypt ( blSign, &blSignKey, NULL, 1 );
	delete                         blSign;
        if ( ! blData->data ) SER ( "blData->data" );
	       blData->len = strlen ( (char *)blData->data );
#ifdef bnplugin_py_DEBUG
	       blData->Show      ( "%s.2.blData.bin", "/tmp/Plugin" );
#endif
	       blData->FileWrite ( "%s/%s.%s", DownloadPath, DownloadName, DownloadType );//2do error check
	delete blData;
    }//if ( strcmp ( DownloadType, "bncsql" ) == 0 )
    else
	blPayLoad.FileWrite ( "%s/%s.%s", DownloadPath, DownloadName, DownloadType );//2do error check
    blPayLoad.data = NULL;

my_return:

    bn_free ( Query    );
    if ( spQuery ) bnSplitPosFree ( spQuery );
    bn_free ( DownloadPath     );
    bn_free ( DownloadName     );
    bn_free ( DownloadType     );
    bn_free ( DownloadWhereKey );
    bn_free ( ClientKey        );
    bn_free ( Bin              );
         tbDst->db = NULL; //else crash @ ios, android
    if ( tbDst ) delete tbDst;

    return NULL;
}//void *bncSQLApplicationDownload ( _bncTable *tb )


void *bncSQLApplicationDelete ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
//error check
    if ( tb->Error[0] ) return NULL;

char        *Query          = NULL;
_bnSplitPos *spQuery        = NULL;
char        *Application    = NULL;

    if ( ! tb ) SEGT ( "! tb" );
    D9 ( "tb->Query=~%s~", tb->Query );

    if ( strlen  ( tb->Query ) <= strlen ( "bncsql application delete " ) ) SEGT ( "Query too short" );
    if ( strncmp ( tb->Query, "bncsql application delete ",strlen ( "bncsql application delete " ) ) == 0 ) Query = strdup ( tb->Query + strlen ( "bncsql application delete " ) );
    else SEGT ( "! crt string" );

    D9 ( "Query=~%s~", Query );

    spQuery = bnSplitPosNew ( Query, -1 );
    spQuery->Delimiter = ',';
    spQuery->Quote     = (char *)"\'";
    bnSplitPosIndex ( spQuery );
    D9 ( "spQuery->Records=%ld", spQuery->Records );
    if ( 1 > spQuery->Records ) SEGT ( "1 > spQuery->Records=%ld", spQuery->Records );

    Application =        bnSplitPosGet ( spQuery, 0 )  ;
    D1 ( "Application   =~%s~", Application );
    unlink ( Application    );

my_return:
    bn_free ( Query          );
    bn_free ( Application    );
    if ( spQuery     ) bnSplitPosFree ( spQuery     );

    return NULL;

}//void *bncSQLApplicationDelete ( _bncTable *tb )


void *bncSQLCertificateDelete ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
//error check
    if ( tb->Error[0] ) return NULL;

char        *Query          = NULL;
_bnSplitPos *spQuery        = NULL;
char        *Certificate    = NULL;
char        *CertificateKey = NULL;

    if ( ! tb ) SEGT ( "! tb" );
    D9 ( "tb->Query=~%s~", tb->Query );

    if ( strlen  ( tb->Query ) <= strlen ( "bncsql certificate delete " ) ) SEGT ( "Query too short" );
    if ( strncmp ( tb->Query, "bncsql certificate delete ",strlen ( "bncsql certificate delete " ) ) == 0 ) Query = strdup ( tb->Query + strlen ( "bncsql certificate delete " ) );
    else SEGT ( "! crt string" );

    D9 ( "Query=~%s~", Query );

    spQuery = bnSplitPosNew ( Query, -1 );
    spQuery->Delimiter = ',';
    spQuery->Quote     = (char *)"\'";
    bnSplitPosIndex ( spQuery );
    D9 ( "spQuery->Records=%ld", spQuery->Records );
    if ( 1 > spQuery->Records ) SEGT ( "1 > spQuery->Records=%ld", spQuery->Records );

    Certificate =        bnSplitPosGet ( spQuery, 0 )  ;
    D9 ( "Certificate   =~%s~", Certificate );

    CertificateKey = strdup ( Certificate );
    if ( strcmp ( ".crt", CertificateKey + strlen ( CertificateKey ) - 4 ) == 0 ) CertificateKey[strlen(CertificateKey)-4] = 0;
    if ( strcmp ( ".pem", CertificateKey + strlen ( CertificateKey ) - 4 ) == 0 ) CertificateKey[strlen(CertificateKey)-4] = 0;
    strcat ( CertificateKey, ".key" );

    D9 ( "CertificateKey=~%s~", CertificateKey );

    unlink ( Certificate    );
    unlink ( CertificateKey );

my_return:
    bn_free ( Query          );
    bn_free ( Certificate    );
    bn_free ( CertificateKey );
    if ( spQuery     ) bnSplitPosFree ( spQuery     );

    return NULL;
}//void *bncSQLCertificateDelete   ( _bncTable *tb )


void *bncSQLCertificateUpload ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
char *Query = NULL;
//error check
    if ( tb->Error[0] ) return NULL;

char CertificateName[255] = "";
//char *Error = bncSQLError;
_bnSplitPos *spQuery     = NULL;
char        *certificate = NULL;
//int          Flag        =    0;
_bnBlob      blKey;
_bnBlob      blCrt;
_bnBlob     *blCrtB64    = NULL;
const char  *password    = NULL;
int          base64      =    1;
_bncTable    tbCrt;
_bncDataBase dbCrt;
char        *Fingerprint = NULL;

    if ( ! tb ) SEGT ( "! tb" );
    D9 ( "tb->Query=~%s~", tb->Query );

    if ( strlen  ( tb->Query ) <= strlen ( "bncsql certificate upload " ) ) SEGT ( "Query too short" );
    if ( strncmp ( tb->Query, "bncsql certificate upload ",strlen ( "bncsql certificate upload " ) ) == 0 ) Query = strdup ( tb->Query + strlen ( "bncsql certificate upload " ) );
    else SEGT ( "! crt string" );

    D9 ( "Query=~%s~", Query );


    spQuery = bnSplitPosNew ( Query, -1 );
    spQuery->Delimiter = ',';
    spQuery->Quote     = (char *)"\'";
    bnSplitPosIndex ( spQuery );
    D7 ( "spQuery->Records=%ld", spQuery->Records );
    if ( 1 > spQuery->Records ) SEGT ( "1 > spQuery->Records=%ld", spQuery->Records );

    certificate =        bnSplitPosGet ( spQuery, 0 )  ;
//Flag        = atol ( bnSplitPosGet ( spQuery, 1 ) );
    if ( ! certificate ) SEGT ( "! certificate" );
    D7 ( "certificate=~%s~", certificate );
//D7 ( "Flag       =%ld" , Flag        );

    blCrt.FileRead ( certificate );
    if ( ! blCrt.len ) SEGT ( "! blCrt.len=%s", certificate );
    //blCrt.Show     ( certificate );//bug4debug

    blKey.Append ( bncSQLRSyncCertificate ); //old bnplugin_crt 2do rm
    //blKey.ShowString ( "keycrtfile" );//bug4debug

    blCrtB64 = bnSSLEncrypt ( &blCrt, &blKey, password, base64 );
    if ( Error[0] ) return NULL;
    if ( ! blCrtB64 ) SER ( "! blCrtB64" );
    //blCrtB64->FileWrite ( "/tmp/outputfile.bin.base64" );//bug4debug

    Fingerprint = bnSSLFingerprint ( certificate, "sha256" );
    if ( ! Fingerprint ) SER ( "! Fingerprint" );
    D2 ( "Fingerprint=~%s~ certificate=~%s~", Fingerprint, certificate );

    dbCrt.Host           = strdup ( bncSQLRSyncHost           );
    dbCrt.Base           = strdup ( bncSQLRSyncBase           );
    dbCrt.User           = strdup ( bncSQLRSyncUser           );
    dbCrt.Pass           = strdup ( bncSQLRSyncPass           );
    dbCrt.Driver         = strdup ( bncSQLRSyncDriver         );
    dbCrt.TLSCertificate = strdup ( bncSQLRSyncTLSCertificate );
    dbCrt.TLSPrivateKey  = strdup ( bncSQLRSyncTLSPrivateKey  );
    if ( tb->db ) {
	if ( tb->db->Home    ) dbCrt.Home    = strdup ( tb->db->Home    );
	if ( tb->db->LibPath ) dbCrt.LibPath = strdup ( tb->db->LibPath );
    }
    //dbCrt.Show ();//bug4debug

    strcpy   ( CertificateName, certificate );
    strcpy   ( CertificateName, basename ( CertificateName ) );
    tbCrt.db = &dbCrt;
    tbCrt.SQLQuery ( "insert into bncsqlrsync (PayLoad,Type,Name,ChkSum) values ('%s','certificate','%s','%s')", (char *)blCrtB64->data, CertificateName, Fingerprint );
    tbCrt.First (); if ( tbCrt.Error[0] ) SEGT ( "tbCrt.Error=%s", tbCrt.Error );

my_return:
    bn_free ( Query );
    if ( spQuery     ) bnSplitPosFree ( spQuery     );
    if ( certificate )           free ( certificate );
    blKey.Free ();
    blCrt.Free ();
    if ( blCrtB64 ) delete blCrtB64;
    tbCrt.Close ();
    dbCrt.Destructor ();
    if ( Fingerprint ) free ( Fingerprint );

    return NULL;

}//void *bncSQLCertificateUpload ( _bncTable *tb )


void *bncSQLCertificateCreate ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
//error check
    if ( tb->Error[0] ) return NULL;

    if ( ! tb ) SER ( "! tb" );
    D9 ( "tb->Query=~%s~", tb->Query );

char *Query = NULL;
    if ( strlen  ( tb->Query ) <= strlen ( "bncsql certificate create " ) ) SER ( "Query too short" );
    if ( strncmp ( tb->Query, "bncsql certificate create ",strlen ( "bncsql certificate create " ) ) == 0 ) Query = strdup ( tb->Query + strlen ( "bncsql certificate create " ) );
    else SER ( "! crt string" );

    D9 ( "Query=~%s~", Query );

_bnSplitPos *spQuery = bnSplitPosNew ( Query, -1 );
    spQuery->Delimiter = ',';
    spQuery->Quote     = (char *)"\'";
    bnSplitPosIndex ( spQuery );
    D9 ( "spQuery->Records=%ld", spQuery->Records );
    if ( 3 > spQuery->Records ) SER ( "3 > spQuery->Records=%ld", spQuery->Records );

char *certificate =        bnSplitPosGet ( spQuery, 0 )  ;
char *crtconfig   =        bnSplitPosGet ( spQuery, 1 )  ;
int   UpLoad      = atol ( bnSplitPosGet ( spQuery, 2 ) );
    if ( ! certificate ) SER ( "! certificate" );//2do via SEGT ...
    if ( ! crtconfig   ) SER ( "! crtconfig"   );

    D9 ( "certificate=~%s~", certificate );
    D9 ( "crtconfig  =~%s~", crtconfig   );
    D9 ( "UpLoad     =%ld" , UpLoad      );

char mBuffer[1024] = "";
    strcat ( mBuffer, certificate );
    if ( strcmp ( ".crt", mBuffer + strlen ( mBuffer ) - 4 ) == 0 ) mBuffer[strlen(mBuffer)-4] = 0;
    if ( strcmp ( ".pem", mBuffer + strlen ( mBuffer ) - 4 ) == 0 ) mBuffer[strlen(mBuffer)-4] = 0;
    strcat ( mBuffer, ".key" );

char *rsafile      = strdup ( mBuffer );
char *rsapassword  = NULL; //2do via crtconfig
int   default_bits =    0; //2do via crtconfig

    bncSQLError[0] = 0;
char *rsafileRX = bnSSLGenRSAKey ( rsafile, rsapassword, default_bits ); //2do test if exsist
    //SIER ( bncSQLError ); 2do ios bncsqlDelete crash @ crt create, if already exsist..
    if ( bncSQLError[0] ) {
	D2 ( "bncSQLError=%s",  bncSQLError );
	strcpy ( tb->Error, bncSQLError );
	return NULL;
    }
    D2 ( "rsafileRX=~%s~", rsafileRX );

char *cacrtfile     = NULL;//2do via crtconfig
char *carsafile     = NULL;//2do via crtconfig
char *carsapassword = NULL;//2do via crtconfig

    bncSQLError[0] = 0;
char *crtfileRX = bnSSLGenCRT ( certificate, crtconfig, rsafile, rsapassword, cacrtfile, carsafile, carsapassword );
    SIER ( bncSQLError );
    D2 ( "crtfileRX=~%s~", crtfileRX );

    if ( UpLoad ) {
	bn_free ( tb->Query );
	tb->SQLQuery ( "bncsql certificate upload '%s'", certificate );
	bncSQLCertificateUpload ( tb );
    }//if ( UpLoad )

    if ( certificate ) free ( certificate );
    if ( crtconfig   ) free ( crtconfig   );
    if ( rsafile     ) free ( rsafile     );

    bnSplitPosFree ( spQuery );

//2do via my_return:

    return NULL;

}//void *bncSQLCertificateCreate ( _bncTable *tb )


void *bncSQLCertificateShow   ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
//error check
    if ( tb->Error[0] ) return NULL;

char        *Query    = NULL;
_bnSplitPos *spQuery  = NULL;
char        *ShowPath = NULL;
_bnDir       bnDir;
_bncTable   *tbDst    = NULL;
_bncTable  **tbs      = NULL;

    if ( ! tb ) SEGT ( "! tb" );
    D9 ( "tb->Query=~%s~", tb->Query );

    if ( strlen  ( tb->Query ) <= strlen ( "bncsql certificate show " ) ) SEGT ( "Query too short" );
    if ( strncmp ( tb->Query, "bncsql certificate show ",strlen ( "bncsql certificate show " ) ) == 0 ) Query = strdup ( tb->Query + strlen ( "bncsql certificate show " ) );
    else SEGT ( "! crt string" );

    D9 ( "Query=~%s~", Query );

    spQuery = bnSplitPosNew ( Query, -1 );
    spQuery->Delimiter = ',';
    spQuery->Quote     = (char *)"\'";
    bnSplitPosIndex ( spQuery );
    D9 ( "spQuery->Records=%ld", spQuery->Records );
    if ( 1 > spQuery->Records ) SEGT ( "1 > spQuery->Records=%ld", spQuery->Records );

    ShowPath =        bnSplitPosGet ( spQuery, 0 )  ;
    D9 ( "ShowPath   =~%s~", ShowPath );

    bnDir.Path     = strdup ( ShowPath );
    bnDir.Name     = strdup ( "*.crt" );
    bnDir.Recursiv = 0;
    bnDir.Open ();
    D9 ( "bnDir.Records=%ld", bnDir.Records );

    tbs = (_bncTable **)malloc( sizeof (_bncTable *) * (bnDir.Records + 1) ); //free = done via bncsql_tbClose
    if ( ! tbs ) SEGT ( "! tbs" );
    memset (  tbs, 0x00       , sizeof (_bncTable *) * (bnDir.Records + 1) );
    tb->Result = tbs;

    tbDst = tbs[0];
    if ( ! tbDst ) {
	D9 ( "tbDst = new _bncTable" );
	tbDst = new _bncTable;
	tbDst->ColumnInsert (            "Name",             NULL,  100,                NULL,    NULL, bn_char      );
	tbDst->ColumnInsert (          "Upload",             NULL,    0,                NULL,    NULL, bn_long      );
	tbDst->ColumnInsert (     "Fingerprint",             NULL,  100,                NULL,    NULL, bn_char      );
	tbs[0] = tbDst;
    }//if ( ! tbDst )
    tbDst = tbs[0];
    if ( ! tbDst ) SEGT ( "! tbDst" );


#define tbSrc bnDir

    while ( _bnDir *diNew = bnDir.Next () ) {
	D9 ( "Include=%02d PathName[%03ld]=~%s~", diNew->Include, bnDir.Fokus, diNew->PathName );

    char *Fingerprint = bnSSLFingerprint ( diNew->PathName, "sha256" );
	if ( ! Fingerprint ) SEGT ( "! Fingerprint" );
	D9 ( "Fingerprint=~%s~ PathName=~%s~", Fingerprint, diNew->PathName );

	tbDst = tbs[tbSrc.Fokus-1];
	if ( ! tbDst ) {
	    D9 ( "tbDst = new _bncTable" );
	    tbDst = new _bncTable;
	    tbDst->ColumnInsert (            "Name",             NULL,  100,                NULL,    NULL, bn_char      );
	    tbDst->ColumnInsert (          "Upload",             NULL,    0,                NULL,    NULL, bn_long      );
	    tbDst->ColumnInsert (     "Fingerprint",             NULL,  100,                NULL,    NULL, bn_char      );
	    tbs[tbSrc.Fokus-1] = tbDst;
	}//if ( ! tbDst )
	tbDst = tbs[tbSrc.Fokus-1];
	if ( ! tbDst ) SEGT ( "! tbDst" );

	//tbDst->Records = 1; tbDst->Show ();//bug4debug
    //amount of Records
	tb->Records++;

	(*(*tbDst)["Name"       ]).SetChar ( (const unsigned char *)diNew->Name );
	(*(*tbDst)["Fingerprint"]).SetChar ( (const unsigned char *)Fingerprint );

	//diNew->Show ();
	//break;//bug4debug
    }//while ( _bnDir *diNew = bnDir.Next () )
    if ( bnDir.Error[0] ) SEGT ( "%s", bnDir.Error );

//amount of Fields
    tb->ColumnFetchDone = 1;//map direct to tb->columns
    tbDst = tbs[0];
    tb->Fields = 0;
    while ( _bncColumn *Column = (*tbDst)[tb->Fields++] ) {}
    tb->Fields--;

    D1 ( "tb->Fields =%ld", tb->Fields  );
    D1 ( "tb->Records=%ld", tb->Records );

my_return:
    bn_free ( Query    );
    bn_free ( ShowPath );
    if ( spQuery     ) bnSplitPosFree ( spQuery     );

    return NULL;

}//void *bncSQLCertificateShow   ( _bncTable *tb )


class _driver {
public:
    _bncTable *tb;
    long long  ID;
         char  Name[255];
         char  Version[255];
         char  Path[255];
         char  Type[255];

    _driver() {
        memset ( this, 0x00, sizeof ( _driver ) );
        tb       = new _bncTable;
        tb->Name = strdup ( "driver" );
        tb->ColumnInsert (              "Name",               &Name,  255,                NULL,    NULL, bn_char      );
        tb->ColumnInsert (           "Version",            &Version,  255,                NULL,    NULL, bn_char      );
        tb->ColumnInsert (              "Type",               &Type,  255,                NULL,    NULL, bn_char      );
        tb->ColumnInsert (              "Path",               &Path,  255,                NULL,    NULL, bn_char      );
        //->ColumnInsert (                "ID",                 &ID,    0,                NULL,    NULL, bn_long_long + bn_AUTO_INCREMENT + bn_PRI_KEY );
    }

    ~_driver() {
        delete tb;
    }

};

void *bncSQLDriverShow ( _bncTable *tb ) {
    D9 ( "tb=%p", tb );

char *Error = tb->Error;
//error check
    if ( tb->Error[0] ) return NULL;

char  Dummy[2048]; //else crash @ ios, bug2 check memset ( tbs...
long         tbsRecords =    0;
_bncTable  **tbs        = NULL;
_bncTable   *tbDst      = NULL;
long         tbsPos     =    0;
_driver      driver;
_bnDir       diDriver;
_bnSplitPos *spBuiltin  = NULL;
char        *Builtin    = NULL;
_bncDataBase dbSrc;

char DriverExt[10];
    strcpy ( DriverExt, ".so" );
#ifdef WIN32
    strcpy ( DriverExt, ".dll" );
#endif
#ifdef __APPLE__
    strcpy ( DriverExt, ".dylib" );
#endif

    if ( ! tb ) SEGT ( "! tb" );
    D9 ( "tb->Query=~%s~", tb->Query );

//Builtin
    printf ( "Builtin=~%s~\n", dbSrc.Builtin() );
    spBuiltin = bnSplitPosNew ( dbSrc.Builtin(), -1 );
    spBuiltin->Delimiter = ';';
    bnSplitPosIndex ( spBuiltin );
    D9 ( "spBuiltin->Records=%ld", spBuiltin->Records );
    tbsRecords += spBuiltin->Records;
//Builtin done

    D2 ( "LibPath=%s", tb->db->LibPath );
    diDriver.Path     = strdup ( tb->db->LibPath );//2do via lib...
    diDriver.Name     = strdup ( "libbncsql-*" );
    diDriver.Recursiv = 0;
    diDriver.Open ();
    if ( diDriver.Error[0] ) SEGT ( "%s", diDriver.Error );
    D2 ( "diDriver.Records=%ld", diDriver.Records );
    tbsRecords += diDriver.Records;

    D9 ( "tbsRecords=%ld", tbsRecords );
    tbs = (_bncTable **)malloc( sizeof (_bncTable *) * (tbsRecords + 1) ); //free = done via bncsql_tbClose
    if ( ! tbs ) SEGT ( "! tbs" );
    memset (  tbs, 0x00       , sizeof (_bncTable *) * (tbsRecords + 1) );
    tb->Result = tbs;

    tbDst = tbs[0];
    if ( ! tbDst ) {
	D9 ( "tbDst = new _bncTable" );
	tbDst = new _bncTable;
	tbDst->ColumnInsert ( driver.tb );
	tbs[0] = tbDst;
    }//if ( ! tbDst )
    tbDst = tbs[0];
    if ( ! tbDst ) SEGT ( "! tbDst" );

    for ( long spBuiltinPos = 0; spBuiltinPos < spBuiltin->Records; spBuiltinPos++ ) {
	Builtin = bnSplitPosGet ( spBuiltin, spBuiltinPos );
	if ( ! Builtin[0] ) {
	    bn_free ( Builtin );
	    continue;
	}
	D1 ( "Builtin=~%s~", Builtin );

	tbsPos = FindNameType ( tb, Builtin, DriverExt );
	//tbsPos = -1; //bug4debug
	if ( 0 > tbsPos ) {
	    tbsPos = tb->Records;
    //amount of Records
	    tb->Records++;
	}
	tbDst = tbs[tbsPos];
	if ( ! tbDst ) {
	    D9 ( "tbDst = new _bncTable" );
	    tbDst = new _bncTable;
	    tbDst->ColumnInsert ( driver.tb );
	    tbs[tbsPos] = tbDst;
	}//if ( ! tbDst )
	tbDst = tbs[tbsPos];
	if ( ! tbDst ) SEGT ( "! tbDst" );

	(*(*tbDst)["Name"       ]).SetChar ( (const unsigned char *)Builtin   );
	(*(*tbDst)["Version"    ]).SetChar ( (const unsigned char *)"0.0.0"   );//2do
	(*(*tbDst)["Type"       ]).SetChar ( (const unsigned char *)DriverExt );
	(*(*tbDst)["Path"       ]).SetChar ( (const unsigned char *)"builtin" );

	bn_free ( Builtin );
    }//for ( long spBuiltinPos = 0; spBuiltinPos < spBuiltin->Records; spBuiltinPos++ )

//local Driver
    while ( _bnDir *diDriverNext = diDriver.Next () ) {
	if ( strcmp ( DriverExt, (char *)diDriverNext->Name + strlen ( diDriverNext->Name ) - strlen ( DriverExt ) ) != 0 ) continue;
	D9 ( "Include=%02d PathName[%03ld]=~%s~", diDriverNext->Include, diDriver.Fokus, diDriverNext->PathName );

    char Name[1024] = "";
	strcpy ( Name, diDriverNext->Name + strlen ( "libbncsql-" ) );
	Name[ strlen ( Name ) - strlen ( DriverExt ) ] = 0;

	tbsPos = FindNameType ( tb, Name, DriverExt );
	//tbsPos = -1; //bug4debug
	if ( 0 > tbsPos ) {
	    tbsPos = tb->Records;
    //amount of Records
	    tb->Records++;
	}
	tbDst = tbs[tbsPos];
	if ( ! tbDst ) {
	    D9 ( "tbDst = new _bncTable" );
	    tbDst = new _bncTable;
	    tbDst->ColumnInsert ( driver.tb );
	    tbs[tbsPos] = tbDst;
	}//if ( ! tbDst )
	tbDst = tbs[tbsPos];
	if ( ! tbDst ) SEGT ( "! tbDst" );

	(*(*tbDst)["Name"       ]).SetChar ( (const unsigned char *)Name                   );
	(*(*tbDst)["Version"    ]).SetChar ( (const unsigned char *)"0.0.0"                );//2do
	(*(*tbDst)["Type"       ]).SetChar ( (const unsigned char *)DriverExt              );
	(*(*tbDst)["Path"       ]).SetChar ( (const unsigned char *)diDriverNext->PathName );
	//diDriverNext->Show ();
	//break;//bug4debug
    }//while ( _bnDir *diDriverNext = diDriver.Next () )
    if ( diDriver.Error[0] ) SEGT ( "%s", diDriver.Error );
//local Apps done

//amount of Fields
    tb->ColumnFetchDone = 1;//map direct to tb->columns
    tbDst = tbs[0];
    tb->Fields = 0;
    while ( _bncColumn *Column = (*tbDst)[tb->Fields++] ) {}
    tb->Fields--;

    D1 ( "tb->Fields =%ld", tb->Fields  );
    D1 ( "tb->Records=%ld", tb->Records );

my_return:
    tbDst->db = NULL; //else crash @ ios, android
    driver.tb->db = NULL;
    bn_free ( Builtin );
    if ( spBuiltin ) bnSplitPosFree ( spBuiltin );
    return NULL;

}//void *bncSQLDriverShow ( _bncTable *tb )

#endif
