//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <bncsql.h>

#include <stdio.h>

#include <bnBlob.h>

#include <albus_log.h>
#ifndef bncSQL_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif


void *bncSQLShow ( const char *Query ) {
char *Error = bncSQLError;
    D8 ( "call" );
    if ( ! Query ) SER ( "! Query" );
    D8 ( "Query=~%s~", Query );

char *TableName = NULL;
char *ModeAs    = NULL;
char *ModeFrom  = NULL;
char *LoadFile  = NULL;
char *Driver    = NULL;

_bncTable bncTable;

std::vector<std::string> vsQuery = bncTable.bnSplit ( Query, ' ' );
    for ( unsigned long vsQueryPos = 0; vsQueryPos < vsQuery.size(); vsQueryPos++ ) {
    std::string sQuery = vsQuery[vsQueryPos];
	D9 ( "[%03ld/%03ld]Query=~%s~", vsQueryPos + 1, vsQuery.size(), sQuery.c_str() );
	if      ( "table"     == sQuery ) TableName = strdup ( vsQuery[vsQueryPos + 1].c_str() );
	else if ( "as"        == sQuery ) ModeAs    = strdup ( vsQuery[vsQueryPos + 1].c_str() );
	else if ( "from"      == sQuery ) ModeFrom  = strdup ( vsQuery[vsQueryPos + 1].c_str() );
	else if ( "driver"    == sQuery ) Driver    = strdup ( vsQuery[vsQueryPos + 1].c_str() );
	else if ( "load_file" == sQuery ) LoadFile  = strdup ( vsQuery[vsQueryPos + 2].c_str() + 1 );
    }//for ( unsigned long vsQueryPos = 0; vsQueryPos < vsQuery.size(); vsQueryPos++ )

    if ( ! ModeFrom  ) SER ( "! ModeFrom"  );
    if ( ! ModeAs    ) SER ( "! ModeAs"    );
    if ( ! TableName ) SER ( "! TableName" );

    D8 ( "TableName =~%s~", TableName );
    D8 ( "ModeAs    =~%s~", ModeAs    );
    D8 ( "ModeFrom  =~%s~", ModeFrom  );
    D8 ( "LoadFile  =~%s~", LoadFile  );
    D8 ( "Driver    =~%s~", Driver    );

//2do _bncTable   bncTables; <- if CreateIncludeName==*
//2do 	    bncTables.SQLQuery ( "show tables" );
//2do     while ( bncTables.Next () ) {
//2do 	//bncTables.Show (); //bug4debug
//2do     _bncColumn *bncColumn = bncTables[ "name" ];
//2do 	if ( ! bncColumn ) SER ( "! bncColumn" );
//2do     const char *TableName = bncColumn->Get ();
//2do 	if ( ! TableName ) SER ( "! TableName" );
//2do 	D8 ( "TableName=~%s~", TableName );
//2do 	break; //bug4debug
//2do }//while ( bncTables.Next () ) SIER ( bncTables.Error );

    if ( strncmp ( ModeFrom, "database", strlen ( "database" ) ) == 0 ) {
	bncTable.SQLQuery ( "select * from %s where 1=0", TableName );
	bncTable.First (); SIER ( bncTable.Error );
	//bncTable.Show (); //bug4debug
    }//if ( strncmp ( ModeFrom, "database", strlen ( "database" ) ) == 0 )
    else if ( strncmp ( ModeFrom, "load_file", strlen ( "load_file" ) ) == 0 ) {
	if ( ! LoadFile ) SER ( "! LoadFile" );
	LoadFile[ strlen ( LoadFile ) - 1 ] = 0;
	D9 ( "LoadFile  =~%s~", LoadFile  );
    _bnBlob blLoadFile;
	blLoadFile.FileRead ( LoadFile );
	//blLoadFile.ShowString ( "LoadFile" ); //bug4debug
    std::vector<std::string> vsDefLines = bncTable.bnSplit ( (char *)blLoadFile.data, '\n' );
	for ( unsigned long vsDefLinesPos = 0; vsDefLinesPos < vsDefLines.size(); vsDefLinesPos++ ) {
	std::string sDefLine = vsDefLines[vsDefLinesPos];
	    D9 ( "[%03ld/%03ld]DefLine=~%s~", vsDefLinesPos + 1, vsDefLines.size(), sDefLine.c_str() );
	    if ( '#' == sDefLine.c_str()[0] ) continue;

	std::vector<std::string> vsDefs = bncTable.bnSplit ( sDefLine, ';' );
	    if ( 2 > vsDefs.size() ) SER ( "2 > vsDefs.size()" );
	    if      ( "serial"   == vsDefs[1] ) { bncTable.ColumnInsert ( vsDefs[0].c_str(), NULL,                          0, NULL, NULL, bn_long + bn_AUTO_INCREMENT + bn_PRI_KEY ); }
	    else if ( "long"     == vsDefs[1] ) { bncTable.ColumnInsert ( vsDefs[0].c_str(), NULL,                          0, NULL, NULL, bn_long                                  ); }
	    else if ( "char"     == vsDefs[1] ) { bncTable.ColumnInsert ( vsDefs[0].c_str(), NULL, atol ( vsDefs[2].c_str() ), NULL, NULL, bn_char                                  ); }
	    else if ( "double"   == vsDefs[1] ) { bncTable.ColumnInsert ( vsDefs[0].c_str(), NULL,                          0, NULL, NULL, bn_double                                ); }
	    else if ( "blob"     == vsDefs[1] ) { bncTable.ColumnInsert ( vsDefs[0].c_str(), NULL,                          0, NULL, NULL, bn_blob                                  ); }
	    else if ( "LONGBLOB" == vsDefs[1] ) { bncTable.ColumnInsert ( vsDefs[0].c_str(), NULL,                          0, NULL, NULL, bn_blob                                  ); }
	    else if ( "longlong" == vsDefs[1] ) { bncTable.ColumnInsert ( vsDefs[0].c_str(), NULL,                          0, NULL, NULL, bn_long_long                             ); }
	    else SER ( "unknown type=%s name=%s", vsDefs[1].c_str (), vsDefs[0].c_str () );
	    SIER ( bncTable.Error );

	    //break; //bug4debug
	}//for ( unsigned long vsDefLinesPos = 0; vsDefLinesPos < vsDefLines.size(); vsDefLinesPos++ )
    }//else if ( strncmp ( ModeFrom, "load_file", strlen ( "load_file" ) ) == 0 )
    else SER ( "unknown ModeFrom" );

_bncTable   bncTableCR;
    bncTableCR.Name = strdup ( TableName );
    if ( strcmp ( "create", ModeAs ) == 0 ) {
     _bncDataBase db;
	db.Driver = strdup ( Driver );
	bncTableCR.db = &db;
	bncTableCR.CreateTable ( 1, &bncTable ); // | ( 0, NULL      );
    }
    else {
	bncTableCR.CreateInclude ( &bncTable ); SIER ( bncTableCR.Error );
    }
    printf ( "%s", bncTableCR.Query );

    return NULL;
}//void *bncSQLShow ( void *Query )
