//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef bncSQLTable_H
#define bncSQLTable_H
#include <bncsql.h>

#include <stdio.h>
#include <vector>
#include <string>

#ifdef bncSQL_DEBUG
# define bncSQLTable_DEBUG
#endif
#ifdef bncSQLTable_DEBUG
# include <albus_log.h>
#endif

#define   ShowTableFokus     0x0001
#define   ShowFieldName      0x0002
#define   ShowFieldNameFull  0x0004
#define   ShowFieldBlobHex   0x0008
#define   ShowDos            0x0010
#define   ShowNull           0x0020
#define   ShowHtml           0x0040
#define   ShowHtmlTableName  0x0080
#define   ShowHtmlFieldName  0x0100
#define   ShowFieldBlobRaw   0x0200
#define   ShowEnvDone        0x0400


class _bncTable {
private:
    void *tbRecord ( void );
    void *Open     ( void );
std::vector<_bncColumn *> *Columns;

public:
//string Tools
std::vector<std::string>  bnSplit   ( const std::string &sSplit, char delim );
                    void  bnReplace ( std::string &str, const std::string &strOut, const std::string& str_In );

         void *SQLQuery     ( const char *format, ... );
         void *Querys       ( const char * );
         void *First        ( void );
         void *Next         ( void );
         void *Prev         ( void );
         void *Last         ( void );

          void *Set          ( _bncTable  * );
          void *ColumnInsert ( _bncTable  * );
    _bncColumn *ColumnInsert ( _bncColumn * );
    _bncColumn *ColumnInsert ( const char *ciName, const void *ciData, long ciSize, unsigned long *ciSizeExtern, const char *ciFormat, long ciType );
         void *Clean        ( void ); //Clean Fields long =0, char = ""
         void *Close        ( void ); //free Query...
         void *Destructor   ( void );

    _bncColumn *operator[]  ( const char *coName    );
    _bncColumn *operator[]  ( unsigned int colIndex );
   const char *Get          ( const char *fName );
         char *GetChar      ( const char *fName );
         long *GetLong      ( const char *fName );
       double *GetDouble    ( const char *fName );

         void *Show         ( void );
         void *ShowHTML     ( void );

         void *Insert       ( void );
         void *Update       ( void );
         void *Delete       ( void );
         void *InsertUpdate ( const char *iuWhere, const char *iuSet );

         void *CreateInclude ( _bncTable *tbSrc );
         void *CreateTable   ( char ctMode, _bncTable *tb );
         char *CreateTableOptions;

         void *TransactionBegin    ( void );
         void *TransactionCommit   ( void );
         void *TransactionRollback ( void );
         void *TransactionEnd      ( char *trError );

             char  Error[255];
             char *Name;
     _bncDataBase *db;     //handle 2 database
    unsigned long  Fokus;
             void *Result; //tb Result
             char *Query;
    unsigned long  Fields;
    unsigned long  Records;
    unsigned long  RecordsLimit;
             long  ColumnFetchDone;
             int   FieldNameRow; //xls, csv
             int   FieldTypeRow; //xls, csv

//Show
             FILE *ShowOutput;
             long  ShowMode;
             long  ShowHeaderDone;
             char *ShowRowSep;
             char *ShowFieldSep;
             char *ShowCharSep;

    _bncTable() {
#ifdef  bncSQLTable_DEBUG
	D7 ( "this=%p", this );//best D7
#endif
	memset ( this, 0x00, sizeof ( _bncTable ) );
	Columns      = new std::vector<_bncColumn *>;
	ShowOutput   = stdout;
	ShowMode    |= ShowFieldName;
	ShowMode    |= ShowNull;
	ShowRowSep   = strdup ( "\n" );//csv-style
	ShowFieldSep = strdup ( ","  );//csv-style
	ShowCharSep  = strdup ( "\"" );//csv-style
    }

    ~_bncTable() {
#ifdef  bncSQLTable_DEBUG
	D7 ( "this=%p", this );//best D7
#endif
	Destructor ();
	bn_free ( Name           );
	bn_free ( Query          );
	bn_free ( ShowRowSep     );
	bn_free ( ShowFieldSep   );
	bn_free ( ShowCharSep    );
	bn_free ( DriverBuffer   );
	bn_free ( CreateTableOptions );
	delete Columns;
    }

    void *DriverBuffer;
    void *Extern;

};

#endif
