//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <bncsql.h>

#include <stdio.h>
#include <string.h>

#include <albus_log.h>
#ifndef bncSQL_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif

#define GetEnv(a,b) {\
	if ( char  *Xenv = getenv ( a ) ) {\
	    if      ( Xenv[0] == '1' ) ShowMode |=  b;\
	    else if ( Xenv[0] == '0' ) ShowMode &= ~b;\
	}\
}


void *_bncTable::ShowHTML ( void ) { ShowMode =   ShowHtml; return Show (); }


void *_bncTable::Show ( void ) {
    D9 ( "this=%p", this );

    if ( Error[0] ) return NULL;

    if ( ! ( ShowMode &   ShowEnvDone ) ) {
	GetEnv ( "dbShowTableFokus"   ,   ShowTableFokus    );
	GetEnv ( "dbShowFieldName"    ,   ShowFieldName     );
	GetEnv ( "dbShowFieldNameFull",   ShowFieldNameFull );
	GetEnv ( "dbShowFieldBlobHex" ,   ShowFieldBlobHex  );
	GetEnv ( "dbShowFieldBlobRaw" ,   ShowFieldBlobRaw  );
	GetEnv ( "dbShowHtml"         ,   ShowHtml          );
	GetEnv ( "dbShowHtmlTableName",   ShowHtmlTableName );
	GetEnv ( "dbShowHtmlFieldName",   ShowHtmlFieldName );
	GetEnv ( "dbShowNull"         ,   ShowNull          );
	GetEnv ( "dbShowDos"          ,   ShowDos           );
	if ( char  *Xenv = getenv ( "dbShowFieldSep" ) ) { free ( ShowFieldSep ); ShowFieldSep = strdup ( Xenv ); }
	if ( char  *Xenv = getenv ( "dbShowRowSep"   ) ) { free ( ShowRowSep   ); ShowRowSep   = strdup ( Xenv ); }
	if ( char  *Xenv = getenv ( "dbShowCharSep"  ) ) { free ( ShowCharSep  ); ShowCharSep  = strdup ( Xenv ); }

	if ( ShowMode &   ShowHtmlTableName ) ShowMode |=   ShowHtml;
	if ( ShowMode &   ShowHtmlFieldName ) ShowMode |=   ShowHtml;
	if ( ShowMode &   ShowHtml ) {
	    ShowMode &= ~  ShowFieldName;
	    ShowMode |=    ShowHtmlTableName;
	    ShowMode |=    ShowHtmlFieldName;
	    free ( ShowFieldSep );
	           ShowFieldSep = strdup ( "<br>\n" );
	    free ( ShowRowSep   );
	           ShowRowSep   = strdup ( "<br>\n" );
	}//if ( ShowMode &   ShowHtml )
	ShowMode |=   ShowEnvDone;
	D8 ( "ShowMode=%ld", ShowMode );
    }//if ( ! ( ShowMode &   ShowEnvDone ) )

//Table Fokus
    if ( ShowMode &   ShowTableFokus ) {
	fprintf ( ShowOutput, "Table=%s", Name       );
	fprintf ( ShowOutput, "/%03ld"  , Fields     );
	fprintf ( ShowOutput, " %04ld"  , Fokus      );
	fprintf ( ShowOutput, "/%04ld"  , Records    );
	if ( db ) {
	    fprintf ( ShowOutput, " %s", (*db).User );
	    fprintf ( ShowOutput, ":%s", (*db).Base );
	    fprintf ( ShowOutput, "@%s", (*db).Host );
	}//if ( db )
	fprintf ( ShowOutput, "%s"      , ShowRowSep );
    }//if ( ShowMode &   ShowTableFokus )

//Top of Table
    if ( ! ShowHeaderDone ) {
	ShowHeaderDone = 1;
    long loop = 0;
	while ( _bncColumn *Column = (*this)[loop++] ) {
	    if      ( ShowMode &   ShowFieldNameFull ) {
		if ( loop != 1 ) fprintf ( ShowOutput, "%s", ShowFieldSep );
		if ( bn_double & Column->Type ) fprintf ( ShowOutput, "%s{0x%08x[%ld,%ld]}", Column->Name, Column->Type, *Column->Size, Column->Scale );
		else                            fprintf ( ShowOutput, "%s{0x%08x[%ld]}"    , Column->Name, Column->Type, *Column->Size                );
	    }
	    else if ( ShowMode &   ShowFieldName ) {
		if ( loop != 1 ) fprintf ( ShowOutput, "%s", ShowFieldSep );
		fprintf ( ShowOutput, "%s"	 , Column->Name );
	    }
	}//while ( _bncColumn *Column = (*this)[loop++] ) {
	if      ( ShowMode &   ShowDos           ) fprintf ( ShowOutput, "\r" );
	if      ( ShowMode &   ShowFieldNameFull ) fprintf ( ShowOutput, "%s", ShowRowSep );
	else if ( ShowMode &   ShowFieldName     ) fprintf ( ShowOutput, "%s", ShowRowSep );
    }//if ( ! ShowHeaderDone )
//Top of Table done

//Data
    if ( ! Records ) return NULL;
long loop = 0;
    while ( _bncColumn *Column = (*this)[loop++] ) {
#ifdef bncSQL_DEBUG
	Column->Show ();
#endif
	if ( loop != 1                      ) { fprintf ( ShowOutput, "%s" ,   ShowFieldSep ); }
	if ( ShowMode &   ShowHtmlTableName ) { fprintf ( ShowOutput, "%s.",           Name ); }
	if ( ShowMode &   ShowHtmlFieldName ) { fprintf ( ShowOutput, "%s=",   Column->Name ); }
	if ( bn_IS_NULL & Column->Type ) {
	    if ( ShowMode &   ShowNull ) fprintf ( ShowOutput, "NULL" );
	    else {
		if ( bn_char & Column->Type ) fprintf ( ShowOutput, "%s%s%s", ShowCharSep, "", ShowCharSep );
		if ( bn_blob & Column->Type ) fprintf ( ShowOutput, "%s%s%s", ShowCharSep, "", ShowCharSep );
		else                          fprintf ( ShowOutput, "%s"    ,              ""              );
	    }
	}//if ( bn_IS_NULL & Column->Type )
	else if ( bn_blob & Column->Type ) {
	    if ( ShowMode &   ShowFieldBlobHex ) {
	    unsigned long  blob_len;
	    unsigned char *blob_data;
		Column->GetBlob ( &blob_data, &blob_len );
		fprintf ( ShowOutput, "0x" );
	    char *xxxa= (char *)blob_data;
		for ( unsigned long xx=0 ; xx < blob_len ; xx++ )
		fprintf ( ShowOutput, "%02X", (unsigned char)xxxa[xx] );
	    }//if ( ShowMode &   ShowFieldBlobHex )
	    else if ( ShowMode &   ShowFieldBlobRaw ) {
	    unsigned long  blob_len;
	    unsigned char *blob_data;
		Column->GetBlob ( &blob_data, &blob_len );
	    char *xxxa= (char *)blob_data;
		for ( unsigned long xx=0 ; xx < blob_len ; xx++ )
		fprintf ( ShowOutput, "%c", (unsigned char)xxxa[xx] );
	    }//else if ( ShowMode &   ShowFieldBlobRaw )
	    else {
		fprintf ( ShowOutput, "%s%s%s", ShowCharSep, "!blob!", ShowCharSep );
	    }
	}//if ( bn_blob & Column->Type )
	else {
	const char *gChar = Column->Get();
	    SIER ( Column->Error );
	    if ( ! gChar ) SER ( "! gChar" );
	    if ( bn_char & Column->Type ) {
		fprintf ( ShowOutput, "%s", ShowCharSep );
		for ( unsigned long gCharPos = 0; gCharPos < strlen ( gChar ); gCharPos++ ) {
		     if ( ShowCharSep[0] == gChar[gCharPos] ) fprintf ( ShowOutput, "%s", ShowCharSep );
		     fprintf ( ShowOutput, "%c", gChar[gCharPos] );
		}
		fprintf ( ShowOutput, "%s", ShowCharSep );
	    }
	    else fprintf ( ShowOutput, "%s%s%s", ShowCharSep, gChar, ShowCharSep );
	}//else if ( bn_blob & Column->Type )

    }//while ( _bncColumn *Column = (*this)[loop++] )

    if ( ShowMode &   ShowDos ) fprintf ( ShowOutput, "\r" );
    if ( ShowRowSep           ) fprintf ( ShowOutput, "%s", ShowRowSep );

    return NULL;

}//void *_bncTable::Show ( void )
