//Copyright 2017 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#define bncsql_BUILTIN

#ifdef bncsql_BUILTIN
char *bncsql_dbOpen          ( void * );
char *bncsql_dbClose         ( void * );
char *bncsql_tbOpen          ( void * );
char *bncsql_tbColumnInsert  ( void *, _bncColumn *co, unsigned long );
char *bncsql_tbClose         ( void * );
char *bncsql_tbRecord        ( void * );
char *bncsql_tbColumn        ( void *, const char *, unsigned char **, unsigned long * );
char *bncsql_tbSQLBuild      ( void * );
char *bncsql_coDEF           ( void * );
# define bncsql_BUILTIN_DRIVER { \
    if ( strcmp ( Driver, "bncsql" ) == 0 ) { \
	if (                 bncsql_dbOpen ) { \
	    dbOpen         = bncsql_dbOpen        ; \
	    dbClose        = bncsql_dbClose       ; \
	    tbOpen         = bncsql_tbOpen        ; \
	    tbColumnInsert = bncsql_tbColumnInsert; \
	    tbClose        = bncsql_tbClose       ; \
	    tbRecord       = bncsql_tbRecord      ; \
	    tbColumn       = bncsql_tbColumn      ; \
	    tbSQLBuild     = bncsql_tbSQLBuild    ; \
	    coDEF          = bncsql_coDEF         ; \
	    return Error; \
	} \
    } \
}
# define bncsql_BUILTIN_HAVE "bncsql;"
#else
# define bncsql_BUILTIN_DRIVER
# define bncsql_BUILTIN_HAVE
#endif
