//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define DEBUG
//#define bncsql_py_DEBUG
#include <stdio.h>
#include <math.h>
#include <Python.h>
#include <json-c/json.h>
#include <string>
#include <vector>

#include "base64.h"
#include <bncsql.h>

#ifdef DEBUG
# define bncsql_py_DEBUG
#endif
#include <albus_log.h>
#ifndef bncsql_py_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif
//2do python native obj, rm json

json_object *joRoot = NULL;//2do free
       char *tx     = NULL;


class _bncTableStack {
public:
    char          Address[50];
    _bncTable    *tb;
    _bncDataBase *db;

    _bncTableStack () {
	memset ( this, 0x00, sizeof ( _bncTableStack ) );
	D9 ( "_bncTableStack tb" );
	tb = new _bncTable;
	D9 ( "_bncTableStack db" );
	db = new _bncDataBase;
	tb->db = db;
	D9 ( "_bncTableStack done" );
    }

    ~_bncTableStack () {
	if ( tb ) {
	    D9 ( "~_bncTableStack db" );
	    delete db;
	    tb->db = NULL;
	    D9 ( "~_bncTableStack tb" );
	    delete tb;
	    tb = NULL;
	    D9 ( "~_bncTableStack done" );
	}
    }
};


std::vector<_bncTableStack *> vbncTableStack;


_bncTableStack *vbncTableStackNew ( void ) {
_bncTableStack *vs = new _bncTableStack;
    D9 ( "vs=%p", vs );
    sprintf ( vs->Address, "%p", vs );
    vbncTableStack.push_back ( vs );
    return vs;
}//_bncTableStack *vbncTableStackNew ( void )


_bncTableStack *vbncTableStackGet ( char *vsAddress ) {
    D9 ( "vbncTableStackGet vsAddress=%s", vsAddress );
    for ( unsigned long vbncTableStackPos = 0; vbncTableStackPos < vbncTableStack.size(); vbncTableStackPos++ ) {
    _bncTableStack *vs = vbncTableStack[vbncTableStackPos];
	D9 ( "vbncTableStackGet vs=%p", vs );
	if ( strcmp ( vs->Address, vsAddress ) == 0 ) {
	    return vs;
	}
    }
    return NULL;
}//_bncTableStack *vbncTableStackGet ( char *vsAddress )


void *vbncTableStackDelete ( char *vsAddress ) {
    D9 ( "vbncTableStackDelete vsAddress=%s", vsAddress );
    for ( unsigned long vbncTableStackPos = 0; vbncTableStackPos < vbncTableStack.size(); vbncTableStackPos++ ) {
    _bncTableStack *vs = vbncTableStack[vbncTableStackPos];
	D9 ( "vbncTableStackDelete vs=%p", vs );
	if ( strcmp ( vs->Address, vsAddress ) == 0 ) {
	    delete vs;
	    vbncTableStack.erase ( vbncTableStack.begin() +  vbncTableStackPos );
	    return NULL;
	}
    }
    return NULL;
}//_bncTableStack *vbncTableStackGet ( char *vsAddress )


extern "C" {

static PyObject* bncsqlRecord ( PyObject* self, PyObject* args ) {
char *rxFokus  = NULL;
char *rxHandle = NULL;
    PyArg_ParseTuple ( args, "ss", &rxHandle, &rxFokus );
    D9 ( "rxHandle=%s", rxHandle );
    D9 ( "rxFokus =%s", rxFokus  );
//bug2 crash if no rxHandle
_bncTableStack *vs = vbncTableStackGet ( rxHandle );
    D9 ( "vs=%p", vs );

long  bncsqlRecordFokus = atol (rxFokus );
    D9 ( "bncsqlRecordFokus=%ld", bncsqlRecordFokus );

_bncTable *tb = vs->tb;
    tb->Fokus = bncsqlRecordFokus; // out , some sql-server has tb->Records = -1;
void *tb__Next = tb->Next ();
    D9 ( "tb__Next=%p", tb__Next );
unsigned long  tb__Fokus = tb->Fokus;
    if ( ! tb__Next ) tb__Fokus = -1;
    joRoot = json_object_new_object();
    json_object_object_add ( joRoot, "Error"  , json_object_new_string ( tb->Error   ) );
    json_object_object_add ( joRoot, "Fields" , json_object_new_int    ( tb->Fields  ) );
    json_object_object_add ( joRoot, "Records", json_object_new_int    ( tb->Records ) );
    json_object_object_add ( joRoot, "Fokus"  , json_object_new_int    ( tb__Fokus   ) );

//joRecord[]
    json_object *joRecord = json_object_new_array();
long loop = 0;
    while ( _bncColumn *co = (*tb)[loop++] ) {
	if ( bn_blob & co->Type ) {

	std::string b64 = "";
//if ( strncmp ( co->Name + strlen(co->Name) - strlen ("Image"), "Image", strlen ("Image") ) == 0 ) {
		D9 ( "co->Name=%s", co->Name );
	    unsigned long  blob_len;
	    unsigned char *blob_data;
		co->GetBlob ( &blob_data, &blob_len );
		if ( blob_len ) {
		    b64 = base64_encode(blob_data, blob_len);
		}
		//D9 ( "b64=%s", b64.c_str () );
//}//if ( strncmp ( co->Name + strlen(co->Name) - strlen ("Image"), "Image", strlen ("Image") ) == 0 )
//else {
//char myBlob[255];
//sprintf ( myBlob, "blob: size=%ld", *co->Size );
//b64 = myBlob;
//}
	    if ( bn_IS_NULL & co->Type ) json_object_array_add ( joRecord, json_object_new_string ( "NULL" ) );
	    else                         json_object_array_add ( joRecord, json_object_new_string ( b64.c_str () ) );
	}
	else {
	char *coRecord = (char *)co->Get ();
	    if ( coRecord ) json_object_array_add ( joRecord, json_object_new_string ( coRecord ) );
	    else            json_object_array_add ( joRecord, json_object_new_string ( "NULL"   ) );
	}
    }//while ( _bncColumn *co = (*tb)[loop++] )
    json_object_object_add ( joRoot, "Record" , joRecord );
//joRecord[]

    std::string joRootString = json_object_to_json_string ( joRoot );
    D9 ( "joRootString=%s", joRootString.c_str () );
    bn_free ( tx );
    tx = new char[ joRootString.size() + 1 ];
    strcpy ( tx, joRootString.c_str () );
    return Py_BuildValue("s", tx );

}//static PyObject* bncsqlRecord ( PyObject* self, PyObject* args )


static PyObject* bncsqlQuery ( PyObject* self, PyObject* args ) {
char *rxQuery  = NULL;
char *rxHandle = NULL;
    PyArg_ParseTuple ( args, "ss", &rxHandle, &rxQuery );
    D9 ( "rxQuery=%s" , rxQuery  );
    D9 ( "rxHandle=%s", rxHandle );

_bncTableStack *vs = vbncTableStackGet ( rxHandle );
    D9 ( "vs=%p", vs );
_bncTable *tb = vs->tb;
    //tb->Close ();// -> Error: DriverNotLoad! error @ stderr/stdout
    tb->Query = strdup ( rxQuery );
    tb->First ();
    D9 ( "tb->Error=~%s~", tb->Error );
    //tb->Show ();

    joRoot = json_object_new_object();
    json_object_object_add ( joRoot, "Error" , json_object_new_string ( tb->Error   ) );
    json_object_object_add ( joRoot, "ColCnt", json_object_new_int    ( tb->Fields  ) );
    json_object_object_add ( joRoot, "RowCnt", json_object_new_int    ( tb->Records ) );

//joField[]
//joType[]
    json_object *joField = json_object_new_array();
    json_object *joType  = json_object_new_array();
long loop = 0;
    while ( _bncColumn *co = (*tb)[loop++] ) {
	D9 ( "co->Name=~%s~", co->Name );
	json_object_array_add ( joField, json_object_new_string ( co->Name ) );
	if      ( bn_char       & co->Type ) json_object_array_add ( joType , json_object_new_string ( "bn_char"      ) );
	else if ( bn_long       & co->Type ) json_object_array_add ( joType , json_object_new_string ( "bn_long"      ) );
	else if ( bn_long_long  & co->Type ) json_object_array_add ( joType , json_object_new_string ( "bn_long_long" ) );
	else if ( bn_double     & co->Type ) json_object_array_add ( joType , json_object_new_string ( "bn_double"    ) );
	else if ( bn_blob       & co->Type ) json_object_array_add ( joType , json_object_new_string ( "bn_blob"      ) );
	else                                 json_object_array_add ( joType , json_object_new_string ( "bn_error"     ) );
    }//while ( _bncColumn *co = (*tb)[loop++] )
    json_object_object_add ( joRoot, "Cols"   , joField );
    json_object_object_add ( joRoot, "Types"  , joType  );
//joField[] done

std::string joRootString = json_object_to_json_string ( joRoot );
    bn_free ( tx );
    tx = new char[ joRootString.size() + 1 ];
    strcpy ( tx, joRootString.c_str () );

    return Py_BuildValue("s", tx );

}//static PyObject* bncsqlQuery ( PyObject* self, PyObject* args )


char *joGet ( json_object *jo_rx, const char *jo_name ) {
json_object *obj_name = json_object_object_get ( jo_rx, jo_name );
    if ( ! obj_name ) return (char *)"";
char *my_obj = (char *)json_object_get_string ( obj_name );
    return my_obj;
}//char *joGet ( json_object *jo_rx, const char *jo_name )


static PyObject* bncsqlNew ( PyObject* self, PyObject* args ) {
char *rxNew = NULL;
    PyArg_ParseTuple ( args, "s", &rxNew );
    D9 ( "rxNew=~%s~", rxNew );

json_object *jo_rx = json_tokener_parse ( rxNew );
    D9 ( "jo_rx=%p", jo_rx );

char pyError[1024] = "";

_bncTableStack *vs = vbncTableStackNew ();
    if ( vs ) {
    D9 ( "vs=%p", vs );
    _bncTable *tb = vs->tb;
	if ( tb ) {
	    if ( tb->db ) {
		D9 ( "dbHost=%s", joGet ( jo_rx, "dbHost" ) );
		albus_log_level           = atol   ( joGet ( jo_rx, "dbLogLevel"          ) );
		albus_log_stdio           = strdup ( joGet ( jo_rx, "dbLogStdio"          ) );
		albus_log_file            = strdup ( joGet ( jo_rx, "dbLogFile"           ) );
		albus_log_syslog          = atol   ( joGet ( jo_rx, "dbLogSyslog"         ) );
		albus_log_modul           = strdup ( joGet ( jo_rx, "dbLogModul"          ) );
		tb->db->LibPath           = strdup ( joGet ( jo_rx, "dbLibPath"           ) );
		tb->db->Home              = strdup ( joGet ( jo_rx, "dbHome"              ) );
		tb->db->Host              = strdup ( joGet ( jo_rx, "dbHost"              ) );
		tb->db->Base              = strdup ( joGet ( jo_rx, "dbBase"              ) );
		tb->db->User              = strdup ( joGet ( jo_rx, "dbUser"              ) );
		tb->db->Pass              = strdup ( joGet ( jo_rx, "dbPass"              ) );
		tb->db->Driver            = strdup ( joGet ( jo_rx, "dbDriver"            ) );
		tb->db->Port              = atol   ( joGet ( jo_rx, "dbPort"              ) );
		tb->db->Options           = strdup ( joGet ( jo_rx, "dbOptions"           ) );
		tb->db->TLSCertificate    = strdup ( joGet ( jo_rx, "dbTLSCertificate"    ) );
		tb->db->TLSPrivateKey     = strdup ( joGet ( jo_rx, "dbTLSPrivateKey"     ) );
		tb->db->TLSPrivateKeyPass = strdup ( joGet ( jo_rx, "dbTLSPrivateKeyPass" ) );
		tb->db->TLSFingerprint00  = strdup ( joGet ( jo_rx, "dbTLSFingerprint00"  ) );
		tb->db->TLSFingerprint01  = strdup ( joGet ( jo_rx, "dbTLSFingerprint01"  ) );
		tb->db->TLSFingerprint02  = strdup ( joGet ( jo_rx, "dbTLSFingerprint02"  ) );
		tb->db->TLSFingerprint03  = strdup ( joGet ( jo_rx, "dbTLSFingerprint03"  ) );
		tb->db->TLSFingerprint04  = strdup ( joGet ( jo_rx, "dbTLSFingerprint04"  ) );
		if ( ( albus_log_stdio           ) && ( ! albus_log_stdio[0]           ) ) bn_free ( albus_log_stdio           );
		if ( ( albus_log_file            ) && ( ! albus_log_file[0]            ) ) bn_free ( albus_log_file            );
		if ( ( albus_log_modul           ) && ( ! albus_log_modul[0]           ) ) bn_free ( albus_log_modul           );
		if ( ( tb->db->LibPath           ) && ( ! tb->db->LibPath[0]           ) ) bn_free ( tb->db->LibPath           );
		if ( ( tb->db->Home              ) && ( ! tb->db->Home[0]              ) ) bn_free ( tb->db->Home              );
		if ( ( tb->db->Host              ) && ( ! tb->db->Host[0]              ) ) bn_free ( tb->db->Host              );
		if ( ( tb->db->Base              ) && ( ! tb->db->Base[0]              ) ) bn_free ( tb->db->Base              );
		if ( ( tb->db->User              ) && ( ! tb->db->User[0]              ) ) bn_free ( tb->db->User              );
		if ( ( tb->db->Pass              ) && ( ! tb->db->Pass[0]              ) ) bn_free ( tb->db->Pass              );
		if ( ( tb->db->Driver            ) && ( ! tb->db->Driver[0]            ) ) bn_free ( tb->db->Driver            );
		if ( ( tb->db->TLSCertificate    ) && ( ! tb->db->TLSCertificate[0]    ) ) bn_free ( tb->db->TLSCertificate    );
		if ( ( tb->db->TLSPrivateKey     ) && ( ! tb->db->TLSPrivateKey[0]     ) ) bn_free ( tb->db->TLSPrivateKey     );
		if ( ( tb->db->TLSPrivateKeyPass ) && ( ! tb->db->TLSPrivateKeyPass[0] ) ) bn_free ( tb->db->TLSPrivateKeyPass );
		if ( ( tb->db->TLSFingerprint00  ) && ( ! tb->db->TLSFingerprint00[0]  ) ) bn_free ( tb->db->TLSFingerprint00  );
		if ( ( tb->db->TLSFingerprint01  ) && ( ! tb->db->TLSFingerprint01[0]  ) ) bn_free ( tb->db->TLSFingerprint01  );
		if ( ( tb->db->TLSFingerprint02  ) && ( ! tb->db->TLSFingerprint02[0]  ) ) bn_free ( tb->db->TLSFingerprint02  );
		if ( ( tb->db->TLSFingerprint03  ) && ( ! tb->db->TLSFingerprint03[0]  ) ) bn_free ( tb->db->TLSFingerprint03  );
		if ( ( tb->db->TLSFingerprint04  ) && ( ! tb->db->TLSFingerprint04[0]  ) ) bn_free ( tb->db->TLSFingerprint04  );
#ifdef __ANDROID__
		albus_log_syslog = 1; //2do @ GUI
#endif
		//albus_log_level  = 9;                       //bug4debug
		//albus_log_stdio  = strdup ( "stderr"     ); //bug4debug
		//albus_log_file   = strdup ( "bncsql.log" ); //bug4debug
		//tb->db->Show (); //bug4debug
	    }//if ( tb->db )
	    else sprintf ( pyError, "! tb->db" );
	}//if ( tb )
	else sprintf ( pyError, "! tb" );
    }//if ( vs )
    else sprintf ( pyError, "! vs" );

    D2 ( "Handle=~%s~ pyError=~%s~", vs->Address, pyError );

    joRoot = json_object_new_object();
    json_object_object_add ( joRoot, "Error"  , json_object_new_string ( pyError ) );
    json_object_object_add ( joRoot, "Handle" , json_object_new_string ( vs->Address ) );
    std::string joRootString = json_object_to_json_string ( joRoot );
    bn_free ( tx );
    tx = new char[ joRootString.size() + 1 ];
    strcpy ( tx, joRootString.c_str () );
    return Py_BuildValue("s", tx );

}//static PyObject* bncsqlNew ( PyObject* self, PyObject* args )


static PyObject* bncsqlDelete ( PyObject* self, PyObject* args ) {
//bug2 crash @ android if Driver not found, test via bncsql create certificate
char *rxHandle = NULL;
    PyArg_ParseTuple ( args, "s", &rxHandle );
    D2 ( "Handle=~%s~", rxHandle );
    vbncTableStackDelete ( rxHandle );
    D9 ( "Handle=~%s done~", rxHandle );
    joRoot = json_object_new_object();
    json_object_object_add ( joRoot, "Error"  , json_object_new_string ( ""  ) );
    std::string joRootString = json_object_to_json_string ( joRoot );
    bn_free ( tx );
    tx = new char[ joRootString.size() + 1 ];
    strcpy ( tx, joRootString.c_str () );
    return Py_BuildValue("s", tx );
}//static PyObject* bncsqlDelete ( PyObject* self, PyObject* args )


static PyMethodDef libbncsql_py_methods[] = {
    { "bncsqlNew"   , bncsqlNew   , METH_VARARGS },
    { "bncsqlDelete", bncsqlDelete, METH_VARARGS },
    { "bncsqlQuery" , bncsqlQuery , METH_VARARGS },
    { "bncsqlRecord", bncsqlRecord, METH_VARARGS },
    { NULL          , NULL                       }
};


void initlibbncsql_py ( void ) { (void)Py_InitModule ( "libbncsql_py", libbncsql_py_methods ); }

}
