//Copyright 2017 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define bnSSL_DEBUG
#ifdef  bnSSL_ENABLED
#ifndef bnSSL_H
#define bnSSL_H
#ifdef DEBUG
# define bnSSL_DEBUG
#endif

#include <bnBlob.h>

_bnBlob *bnSSLBase2Encrypt ( const char *Base64              );
_bnBlob *bnSSLEncrypt2Sign ( _bnBlob *Encrypt, _bnBlob *Key  );
_bnBlob *bnSSLSign2Data    ( _bnBlob *Sign   , _bnBlob *Cert );

char *bnSSLEncrypt2Base    ( _bnBlob *Encrypt             );
_bnBlob *bnSSLSign2Encrypt ( _bnBlob *Sign, _bnBlob *Cert );
_bnBlob *bnSSLData2Sign    ( _bnBlob *Data, _bnBlob *Key  );

char *bnSSLGenRSAKey ( char *rsafile, char *rsapasswd, int rsabits );
char *bnSSLGenCRT    ( char *crtfile, char *crtconfig, char *rsafile, char *rsapasswd, char *cacrtfile, char *carsafile, char *carsapasswd );

_bnBlob *bnSSLEncrypt ( _bnBlob *Data, _bnBlob *Key, const char *password, int base64 );
_bnBlob *bnSSLDecrypt ( _bnBlob *Data, _bnBlob *Key, const char *password, int base64 );

char *bnSSLFingerprint ( const char *, const char * );

#endif
#endif
