//Copyright 2017-2018 blacknoise.at
//
//   You may use this file WITHOUT CHANGES according to Apache License, Version 2.0.
//   Modifications of this file is NOT allowed without prior written permission.
//   For written permission, please contact us via http://www.blacknoise.at/?Contact
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//
//#define bnplugin_py_DEBUG
#ifdef HAVE_CONFIG
# include <config.h>
#endif

#include <stdio.h>
#include <libgen.h> //4 dirname !!!
#include <math.h>
#include <errno.h>
#include <Python.h>

#include <unistd.h>
#include <openssl/ssl.h>
#include <vector>
#include <json-c/json.h>

#include <bnSSL.h>

//2do error @ ios #include "bnplugin_crt.h"
extern char bncSQLRSyncCertificate[];
#define bnplugin_crt bncSQLRSyncCertificate

#include "base64.h"
#include "bnBlob.h"

#ifdef DEBUG
# define bnplugin_py_DEBUG
#endif
#include "albus_log.h"
#ifndef bnplugin_py_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif


#define Error MainError
extern char Error[];

char *tmpDir = NULL;
char *Expand = NULL;
//_bnBlob TarBlob.((unsigned long)0);//2do mk class
_bnBlob   *blData = NULL;

char *API_Version = NULL;
char *ClientKey   = NULL;
char *MTime       = NULL;


#define TAR_HEADER_LEN 0x200


typedef struct  {
    char   Name[100];//  0 100 File name
    char     Mode[8];//100 8   File mode
    char    Owner[8];//108 8   Owner's numeric user ID
    char    Group[8];//116 8   Group's numeric user ID
    char    Size[12];//124 12  File size in bytes (octal base)
    char    Time[12];//136 12  Last modification time in numeric Unix time format (octal)
    char Checksum[8];//148 8   Checksum for header record
    char        Link;//156 1   Link indicator (file type)
    char Linked[100];//157 100 Name of linked file
//ustar area
    unsigned long SizeFile;
    unsigned long SizeData;
    unsigned long Offset;
} _TarHeader;


std::vector<_TarHeader *> TarHeaderStack;//2do mk class


void TarHeaderSet ( _TarHeader *TarHeader ) {
    TarHeader->SizeFile = 0;
    TarHeader->SizeData = 0;
long SizeFile = 0;
    sscanf ( TarHeader->Size, "%12o", &SizeFile );
    TarHeader->SizeFile  = SizeFile;
    TarHeader->SizeData  = SizeFile;
    TarHeader->SizeData |=    0x1FF;//Padding
    TarHeader->SizeData +=        1;
}//void TarHeaderSet ( _TarHeader *TarHeader )


void TarHeaderShow ( _TarHeader *TarHeader ) {
    D7 ( "~%s~"        , TarHeader->Name     );
    D7 ( "     Mode=%s", TarHeader->Mode     );
    D7 ( "    Owner=%s", TarHeader->Owner    );
    D7 ( "    Group=%s", TarHeader->Group    );
    D7 ( "     Size=%s", TarHeader->Size     );
    D7 ( "     Time=%s", TarHeader->Time     );
    D7 ( " Checksum=%s", TarHeader->Checksum );
    D7 ( "     Link=%x", TarHeader->Link     );
    D7 ( "   Linked=%s", TarHeader->Linked   );
    D7 ( " SizeFile=%12ld 0x%8x", TarHeader->SizeFile, TarHeader->SizeFile );
    D7 ( " SizeData=%12ld 0x%8x", TarHeader->SizeData, TarHeader->SizeData );
    D7 ( "   Offset=%12ld 0x%8x", TarHeader->Offset  , TarHeader->Offset   );
}//void TarHeaderShow ( _TarHeader *TarHeader )


char *FindModule ( char *Module ) {
    D9 ( "Module=~%s~", Module );

char ModulePYC[1024] = "";
    sprintf ( ModulePYC, "%s.pyc", Module );
_TarHeader *TarHeader = NULL;
    for ( unsigned long TarHeaderStackPos = 0; TarHeaderStackPos < TarHeaderStack.size(); TarHeaderStackPos++ ) {
	TarHeader = TarHeaderStack[TarHeaderStackPos];
	D9 ( "~%s~" , TarHeader->Name );
	if ( strcmp ( TarHeader->Name, ModulePYC ) == 0 ) break;
	TarHeader = NULL;
    }//for ( unsigned long TarHeaderStackPos = 0; TarHeaderStackPos < TarHeaderStack.size(); TarHeaderStackPos++ )
    if ( ! TarHeader ) SER ( "file: ~%s~ not found !", ModulePYC );

    D9 ( "~%s~", TarHeader->Name );
    return NULL;

}//char *FindModule ( char *Module )


char *LoadModule ( char *TarFile ) {
    D9 ( "TarFile=~%s~", TarFile );

    if ( ! blData ) SER ( "! blData" );

_TarHeader *TarHeader = NULL;
    for ( unsigned long TarHeaderStackPos = 0; TarHeaderStackPos < TarHeaderStack.size(); TarHeaderStackPos++ ) {
	TarHeader = TarHeaderStack[TarHeaderStackPos];
	D9 ( "~%s~" , TarHeader->Name );
	if ( strcmp ( TarHeader->Name, TarFile ) == 0 ) break;
	TarHeader = NULL;
    }//for ( unsigned long TarHeaderStackPos = 0; TarHeaderStackPos < TarHeaderStack.size(); TarHeaderStackPos++ )
    if ( ! TarHeader ) SER ( "file: ~%s~ not found !", TarFile );

    D9 ( "~%s~", TarHeader->Name );
#ifdef bnplugin_py_DEBUG
    TarHeaderShow ( TarHeader );
#endif

char *tmpFile = NULL;//2do free
    if ( ! tmpDir ) tmpDir = strdup ( "/tmp" );
    D9 ( "tmpDir=~%s~", tmpDir );
    tmpFile = new char[1024];//2do free
    memset  ( tmpFile, 0x00, 1024 );
    sprintf ( tmpFile, "%s/bncsql.XXXXXX", tmpDir );

int mkfd = mkstemp ( tmpFile );
    close  ( mkfd );
    unlink ( tmpFile );
    strcat ( tmpFile, TarFile );
    D9 ( "tmpFile=~%s~", tmpFile );

_bnBlob TmpBlob(TarHeader->SizeFile);
    memcpy ( TmpBlob.data, blData->data + TarHeader->Offset + TAR_HEADER_LEN, TmpBlob.size );
             TmpBlob.len = TmpBlob.size;
    errno = 0; //2do @ bnBlob
    TmpBlob.FileWrite ( tmpFile );//2do error check
    if ( errno ) SER ( "errno=%05ld strerror=~%s~", errno, strerror ( errno ) );
    D8 ( "TmpBlob.len=%ld", TmpBlob.len );

    return tmpFile;

}//char *LoadModule ( char *TarFile )


static char *joGet ( json_object *jo_rx, const char *jo_name ) {
json_object *obj_name = json_object_object_get ( jo_rx, jo_name );
    if ( ! obj_name ) return (char *)"";
char *my_obj = (char *)json_object_get_string ( obj_name );
    return my_obj;
}//static char *joGet ( json_object *jo_rx, const char *jo_name )


static void *PluginLoad ( char *Plugin ) {
    D9 ( "call Plugin=%s", Plugin );

_bnBlob blJson ( (unsigned long)0 );
    blJson.FileRead ( "%s", Plugin );
    if ( ! blJson.len ) SER ( "file ~%s~ not found", Plugin );
#ifdef bnplugin_py_DEBUG
    blJson.Show      ( "%s.PluginLoad.0.blJson.bin", Plugin );
    blJson.FileWrite ( "%s.PluginLoad.0.blJson.bin", Plugin );
#endif

json_object *joJson = json_tokener_parse ( (const char *)blJson.data );
    if ( ! joJson ) SER ( "! joJson" );
    D9 ( "joJson=%p", joJson );

    API_Version = joGet ( joJson, "API_Version" );
    if ( strcmp ( API_Version, "1" ) != 0 ) SER ( "API_Version=%s != %s", API_Version, "1" );
    D1 ( "API_Version=~%s~", API_Version );

    ClientKey = joGet ( joJson, "ClientKey" );
    if ( ! ClientKey[0] ) SER ( "! ClientKey[0]" );
    D1 ( "ClientKey=~%s~", ClientKey );

    MTime = joGet ( joJson, "MTime" );
    if ( ! MTime[0] ) SER ( "! MTime[0]" );
    D1 ( "MTime=~%s~", MTime );

char *Bin = joGet ( joJson, "bin" );
    if ( ! Bin[0] ) SER ( "! Bin[0]" );

    if ( strcmp ( ".crt", ClientKey + strlen ( ClientKey ) - 4 ) == 0 ) ClientKey[strlen(ClientKey)-4] = 0;

char ClientKeyPath[1024] = "";
    strcpy ( ClientKeyPath, Plugin );
    strcpy ( ClientKeyPath, dirname ( ClientKeyPath ) );
    D9 ( "ClientKeyPath=%s", ClientKeyPath );

_bnBlob	   blSignKey ( (unsigned long)0 );
	   blSignKey.FileRead  (      "%s/%s.key"          , ClientKeyPath, ClientKey );
    if ( ! blSignKey.len ) SER ( "file %s/%s.key not found", ClientKeyPath, ClientKey );
#ifdef bnplugin_py_DEBUG
	   blSignKey.Show ( "blSignKey" );
#endif

_bnBlob	   blDataCrt ( (unsigned long)0 );
	   blDataCrt.Append ( bnplugin_crt );
    if ( ! blDataCrt.len ) SER ( "! blDataCrt.len" );
#ifdef bnplugin_py_DEBUG
	   blDataCrt.Show ( "blDataCrt" );
#endif

_bnBlob blBin;
    blBin.Append ( Bin );
#ifdef bnplugin_py_DEBUG
	   blBin.Show      ( "%s.0.blBin.bin", Plugin );
	   blBin.FileWrite ( "%s.0.blBin.bin", Plugin );
#endif

_bnBlob   *blSign = bnSSLDecrypt ( &blBin, &blDataCrt, NULL, 1 );
    if ( ! blSign->data ) SER ( "blSign->data" );
#ifdef bnplugin_py_DEBUG
	   blSign->Show      ( "%s.1.blSign.bin", Plugin );
	   blSign->FileWrite ( "%s.1.blSign.bin", Plugin );
#endif

    if (   blData ) {
	delete blData;
	blData = NULL;
    }
    blData = bnSSLDecrypt ( blSign, &blSignKey, NULL, 1 );
    delete                  blSign;
    if ( ! blData->data ) SER ( "blData->data" );
#ifdef bnplugin_py_DEBUG
	   blData->Show      ( "%s.2.blData.bin", Plugin );
	   blData->FileWrite ( "%s.2.blData.bin", Plugin );
#endif

unsigned long blTarPos = 0;
    while ( blTarPos < blData->len ) {
	D9 ( "blTarPos=%12ld 0x%x", blTarPos, blTarPos );

    _TarHeader *TarHeader = (_TarHeader *)malloc   ( TAR_HEADER_LEN );
	memset ( TarHeader, 0x00                   , TAR_HEADER_LEN );
	memcpy ( TarHeader, blData->data + blTarPos, TAR_HEADER_LEN );
	TarHeaderSet ( TarHeader );
	if ( ! TarHeader->SizeFile ) break;
#ifdef bnplugin_py_DEBUG
	TarHeaderShow ( TarHeader );
#endif
	TarHeader->Offset = blTarPos;
	D9 ( "%12ld %s", TarHeader->SizeFile, TarHeader->Name );
	blTarPos += TarHeader->SizeData + TAR_HEADER_LEN;
	TarHeaderStack.push_back ( TarHeader );
	D9 ( "blTarPos=%12ld 0x%x", blTarPos, blTarPos );

	//2do2 if ( strcmp ( ".pyc", TarHeader->Name + strlen ( TarHeader->Name ) - 4 ) == 0 ) continue; //real-time load modules via bnplugin
	//2do2 if ( strcmp ( ".pyo", TarHeader->Name + strlen ( TarHeader->Name ) - 4 ) == 0 ) continue; //real-time load modules via bnplugin

    //Expand files
    _bnBlob TmpBlob(TarHeader->SizeFile);
	memcpy ( TmpBlob.data, blData->data + TarHeader->Offset + TAR_HEADER_LEN, TmpBlob.size );
	         TmpBlob.len = TmpBlob.size;
	errno = 0; //2do @ bnBlob
	TmpBlob.FileWrite ( "%s/%s", Expand, TarHeader->Name );//2do error check

	//break;//bug4debug
    }//while ( blTar_len > 0 )

    //2do free @ reload 
    return NULL;

}//static void *PluginLoad ( char *Plugin )


extern "C" {

    static PyObject* bnplugin_py_close ( PyObject* self, PyObject* args ) {
#ifdef __ANDROID__
	albus_log_syslog = 1;
#endif
	//bus_log_level 2do config from caller
	//albus_log_level  = 9;                       //bug4debug
	//albus_log_stdio  = strdup ( "stderr"     ); //bug4debug
	D9 ( "TarHeaderStack.size ()=%ld", TarHeaderStack.size () );
	TarHeaderStack.clear ();//2do check other 4 free
	Error[0] = 0;
	if ( Error[0] ) return Py_BuildValue("s", Error );
	else            return Py_BuildValue("s", "OK"  );
    }//static PyObject* bnplugin_py_close ( PyObject* self, PyObject* args )


    static PyObject* bnplugin_py_load ( PyObject* self, PyObject* args ) {
	Error[0] = 0;
    char *Name = NULL;
	PyArg_ParseTuple ( args, "sss", &Name, &tmpDir, &Expand );
	D7 ( "Name=~%s~"  , Name   );
	D9 ( "tmpDir=~%s~", tmpDir );
	D7 ( "Expand=~%s~", Expand );
	PluginLoad ( Name );
	if ( Error[0] ) return Py_BuildValue("ssss", Error, ""         , ""       , ""     );
	else            return Py_BuildValue("ssss", "OK" , API_Version, ClientKey, MTime  );
    }//static PyObject* bnplugin_py_load ( PyObject* self, PyObject* args )


    static PyObject* bnplugin_py_find_module ( PyObject* self, PyObject* args ) {
	Error[0] = 0;
	if ( Error[0] ) return Py_BuildValue("s", Error );
    char *Module = NULL;
	PyArg_ParseTuple ( args, "s", &Module );
	D9 ( "Module=~%s~", Module );
	FindModule ( Module );
	if ( Error[0] ) return Py_BuildValue("s", Error );
	else            return Py_BuildValue("s", "OK"  );
    }//static PyObject* bnplugin_py_find_module ( PyObject* self, PyObject* args )


    static PyObject* bnplugin_py_load_module ( PyObject* self, PyObject* args ) {
	Error[0] = 0;
	if ( Error[0] ) return Py_BuildValue("ss", "", Error );
    char *Module = NULL;
	PyArg_ParseTuple ( args, "s", &Module );
	D9 ( "Module=~%s~", Module );
    char ModulePYC[1024] = "";
	sprintf ( ModulePYC, "%s.pyc", Module );
    char *LoadModuleFile = LoadModule ( ModulePYC );
	D7 ( "LoadModuleFile=~%s~", LoadModuleFile );
    PyObject* po = NULL;
	if ( Error[0] ) po = Py_BuildValue ( "ss", "", Error );
	else {
	    if ( LoadModuleFile ) {
		po = Py_BuildValue ( "ss", LoadModuleFile, Error );
		free ( LoadModuleFile );
	    }
	    else {
		po = Py_BuildValue ( "ss", "", "! LoadModuleFile" );
	    }
	}
	return po;
    }//static PyObject* bnplugin_py_load_module ( PyObject* self, PyObject* args )


    static PyMethodDef bnplugin_py_methods[] = {
	{ "bnplugin_py_close"      , bnplugin_py_close      , METH_VARARGS },
	{ "bnplugin_py_load"       , bnplugin_py_load       , METH_VARARGS },
	{ "bnplugin_py_find_module", bnplugin_py_find_module, METH_VARARGS },
	{ "bnplugin_py_load_module", bnplugin_py_load_module, METH_VARARGS },
	{  NULL                    , NULL                   , NULL         }
    };

    void initlibbnplugin_py ( void ) { (void)Py_InitModule ( "libbnplugin_py", bnplugin_py_methods ); }

}//extern "C"
