//Copyright 2016-2017 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define bnDir_DEBUG bug no mallinfo @ darwin
#ifndef bnDir_H
#define bnDir_H
#ifdef DEBUG
# define bnDir_DEBUG
#endif

#include <string.h>
#include <vector>

#ifdef bnDir_DEBUG
# include <albus_log.h>
#endif

#define bnDir_FILE      1
#define bnDir_FILELNK   2
#define bnDir_DIR       4
#define bnDir_DIRLNK    8
#define bnDir_BLK      16
#define bnDir_CHR      32
#define bnDir_FIFO     64
#define bnDir_SOCK    128


class _bnDir {
private:
    std::vector<_bnDir *> *vsDir;
    long                   OpenDone;
    char                  *NameBeg;
    char                  *NameMid;
    char                  *NameEnd;

public:
    void   *Open  ( void );
    void   *Close ( void );
    _bnDir *Next  ( void );
    void   *Show  ( void );

    unsigned long          Fokus;
    unsigned long          Records;
    char                  *PathName;
    char                  *Path;
    char                  *Name;
    long                   Include;
    long                   Recursiv;
    char                   Error[1024];

    _bnDir () {
#ifdef bnDir_DEBUG
	D9 ( "this=%p", this );
#endif
	memset ( this, 0x00, sizeof ( _bnDir ) );
	Include  += bnDir_FILE;
	Recursiv += bnDir_DIR;
    }

    ~_bnDir () {
#ifdef bnDir_DEBUG
	D9 ( "this=%p", this );
#endif
	Close ();
    }

};


void *bnDirTest ( void );

#endif
