//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
//#define DEBUG
//#define bnRC4_DEBUG
#ifdef HAVE_CONFIG
# include <config.h>
#endif
#include "bnRC4.h"
#include <stdio.h>

#include <bnBlob.h>
#include <bnSplitPos.h>
#include <albus_log.h>
#ifndef bnRC4_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif


#ifdef WIN32
static char *strndup( const char *a, size_t b) {
char *c = (char *)malloc (b+1);
    memset  ( c, 0x00, b+1 );
    strncpy ( c,    a, b   );
    return c;
}
#endif


void *_bnRC4::StackAdd ( std::string Key, std::string Val ) {
    D9 ( "this=%p", this );

//update Val
    for ( long vKeyIdxValPos = 0; vKeyIdxValPos < (long)(*vKeyIdxVal).size(); vKeyIdxValPos++ ) {
	D9 ( "%s=[%05ld]~%s~", (*vKeyIdxVal)[vKeyIdxValPos].Key.c_str(), (*vKeyIdxVal)[vKeyIdxValPos].Val.length(), (*vKeyIdxVal)[vKeyIdxValPos].Val.c_str() );
	if ( Key == (*vKeyIdxVal)[vKeyIdxValPos].Key ) {
	    (*vKeyIdxVal)[vKeyIdxValPos].Val = Val;
	    return NULL;
	}//if ( Key == (*vKeyIdxVal)[vKeyIdxValPos].Key )
    }//for ( long vKeyIdxValPos = 0; vKeyIdxValPos < (long)(*vKeyIdxVal).size(); vKeyIdxValPos++ )

//insert new
_KeyIdxVal KeyIdxVal;
    KeyIdxVal.Key = Key;
    KeyIdxVal.Val = Val;
    (*vKeyIdxVal).push_back ( KeyIdxVal );

    return NULL;

}//void *_bnRC4::StackAdd ( std::string Key, std::string Val )


void *_bnRC4::StringsAdd ( const char *String ) {
    D9 ( "this=%p", this );
    if ( ! String ) return NULL;
    D9 ( "String=~%s~", String );

_bnSplitPos *spCfgLine = bnSplitPosNew ( String, -1 );
    spCfgLine->Delimiter = '\n';
    spCfgLine->Quote     = NULL; //unset default
    while ( bnSplitPosNext ( spCfgLine ) ) {
	//bnSplitPosShow ( spCfgLine );

	if ( ! spCfgLine->Len ) continue;
    //remark @ beg
	if ( '#' == spCfgLine->Input[ spCfgLine->Beg ] ) continue;
    //bash export style
	if ( strncmp ( spCfgLine->Input + spCfgLine->Beg, "export ", strlen ( "export " ) ) == 0 ) {
	    spCfgLine->Beg += strlen ( "export " );
	    spCfgLine->Len -= strlen ( "export " );
	}
    //remark
    const char    *Input    = spCfgLine->Input + spCfgLine->Beg;
    unsigned long  InputLen = spCfgLine->Len;
    unsigned long  InputPos = 0;
	for ( InputPos = 0; InputPos < InputLen; InputPos++ ) {
	    D9 ( "Input[%04ld]=~%c~", InputPos, Input[InputPos] );
	    if ( '#' == Input[InputPos] ) {
		spCfgLine->Len = InputPos;
		break;
	    }
	}//for ( InputPos = 0; InputPos < InputLen; InputPos++ )

    //char *Key = strndup ( spCfgLine->Input + spCfgLine->Beg, spCfgLine->Len ); D1 ( "Key=~%s~ Len=%ld", Key, spCfgLine->Len  );//bug4debug

    _bnSplitPos *spKeyVal = bnSplitPosNew ( spCfgLine->Input + spCfgLine->Beg, spCfgLine->Len );
	spKeyVal->Delimiter = '=';
	bnSplitPosIndex ( spKeyVal );
	D9 ( "spKeyVal->Records=%ld", spKeyVal->Records );

	if      ( ! spKeyVal->Records ) {}
	else if ( 1 == spKeyVal->Records ) {
	char *Key = bnSplitPosGet ( spKeyVal, 0 );
	    D9 ( "Key=~%s~ Val=~%s~", Key, "" );
	    StackAdd ( Key, "" );
	    if ( Key ) free ( Key );
	}
	else if ( 2 == spKeyVal->Records ) {
	char *Key = bnSplitPosGet ( spKeyVal, 0 );
	char *Val = bnSplitPosGet ( spKeyVal, 1 );
	    D9 ( "Key=~%s~ Val=~%s~", Key, Val );
	    StackAdd ( Key, Val );
	    if ( Key ) free ( Key );
	    if ( Val ) free ( Val );
	}
	else SER ( "spKeyVal->Records=%ld", spKeyVal->Records );
	bnSplitPosFree ( spKeyVal );

	//break;//bug4debug
    }//while ( bnSplitPosNext ( spCfgLine ) )
    bnSplitPosFree ( spCfgLine );
    return NULL;

}//void *_bnRC4::StringsAdd ( const char *String )


void *_bnRC4::Show ( void ) {
    D9 ( "this=%p", this );

    fprintf ( stderr, "-------------------------------------------------%s%s", __PRETTY_FUNCTION__, CRLF );
    fprintf ( stderr, "Stack.Records=%ld%s", (*vKeyIdxVal).size(), CRLF );
    for ( long vKeyIdxValPos = 0; vKeyIdxValPos < (long)(*vKeyIdxVal).size(); vKeyIdxValPos++ ) {
	fprintf ( stderr, "%s=[%05ld]~%s~%s", (*vKeyIdxVal)[vKeyIdxValPos].Key.c_str(), (*vKeyIdxVal)[vKeyIdxValPos].Val.length(), (*vKeyIdxVal)[vKeyIdxValPos].Val.c_str(), CRLF );
    }
    fprintf ( stderr, "-------------------------------------------------%s%s", __PRETTY_FUNCTION__, CRLF );

    return NULL;

}//void *_bnRC4::Show ( void )


void *_bnRC4::Open ( void ) {
    D8 ( "this=%p", this );

    if ( Error[0]  ) return Error;

    //StackAdd ( "Key001", "Val001" );//bug4debug
    //StackAdd ( "Key001", "Val002" );//bug4debug

    if ( Argv ) {
	D9 ( "Argc=%ld", Argc );
	StackAdd ( "AppName", Argv[0] );

    //via Argv
	for ( long ArgcPos = 1; ArgcPos < Argc; ArgcPos++ ) {
	    D8 ( "Argv[%03ld]=~%s~", ArgcPos, Argv[ArgcPos] );
	_bnSplitPos *spKeyVal = bnSplitPosNew ( Argv[ArgcPos], -1 );
	    spKeyVal->Delimiter = '=';
	    bnSplitPosIndex ( spKeyVal );
	    D9 ( "spKeyVal->Records=%ld", spKeyVal->Records );
	    if      ( 1 == spKeyVal->Records ) {
	    char *Key = bnSplitPosGet ( spKeyVal, 0 );
		D9 ( "Key=~%s~ Val=~%s~", Key, "" );
		StackAdd ( Key, "" );
		if ( Key ) free ( Key );
	    }
	    else if ( 2 == spKeyVal->Records ) {
	    char *Key = bnSplitPosGet ( spKeyVal, 0 );
	    char *Val = bnSplitPosGet ( spKeyVal, 1 );
		D9 ( "Key=~%s~ Val=~%s~", Key, Val );
		StackAdd ( Key, Val );
		if ( Key ) free ( Key );
		if ( Val ) free ( Val );
	    }
	    else SER ( "spKeyVal->Records=%ld", spKeyVal->Records );
	    bnSplitPosFree ( spKeyVal );
	}//for ( long ArgcPos = 0; ArgcPos < Argc; ArgcPos++ )

    //via Argv[0].rc file
	_bnBlob bnBlob;
	    bnBlob.FileRead ( "%s.rc", Argv[0] );
	    StringsAdd ( (const char *)bnBlob.data );

    }//if ( Argv )

    //StringsAdd ( (const char *)"  Key002 =\"Val003\" #abc\nString001=    Str Val001" );//bug4debug
    StringsAdd ( String );

    D9 ( "ReadENV=%s", ReadENV );
    if ( ReadENV ) {
    _bnSplitPos *spCfgLine = bnSplitPosNew ( ReadENV, -1 );
	spCfgLine->Delimiter = ';';
	spCfgLine->Quote     = NULL; //unset default
	spCfgLine->Ignore    = NULL; //unset default
	while ( bnSplitPosNext ( spCfgLine ) ) {
	char *Key = strndup ( spCfgLine->Input + spCfgLine->Beg, spCfgLine->Len );
	    D9 ( "ReadENV=~%s~", Key );
	    if ( char *ENV = getenv ( Key ) ) {
		D9 ( "%s=%s", Key, ENV );
		StackAdd ( Key, ENV );
	    }
	    free ( Key );
	}//while ( bnSplitPosNext ( spCfgLine ) )
    }//if ( ReadENV )

    if ( MustHave ) {
    _bnSplitPos *spCfgLine = bnSplitPosNew ( MustHave, -1 );
	spCfgLine->Delimiter = ';';
	spCfgLine->Quote     = NULL; //unset default
	spCfgLine->Ignore    = NULL; //unset default
	while ( bnSplitPosNext ( spCfgLine ) ) {
	char *Key = strndup ( spCfgLine->Input + spCfgLine->Beg, spCfgLine->Len );
	    D8 ( "MustHave=~%s~", Key );
	    if ( !          Key[0] ) continue;
	    if ( ! GetVal ( Key  ) ) SER ( "Key=~%s~ not found" , Key );
	    free ( Key );
	}//while ( bnSplitPosNext ( spCfgLine ) )
    }//if ( MustHave )

    //Show ();//bug4debug

    return NULL;

}//void *_bnRC4::Open ( void )


void *_bnRC4::Close ( void ) {
    D9 ( "this=%p", this );

    (*vKeyIdxVal).clear ();

    return NULL;

}//void *_bnRC4::Close ( void )


const char *_bnRC4::GetVal ( const char *Key ) {
//same as operator[] but return NULL
    D9 ( "this=%p", this );

    if ( Error[0] ) return NULL;

    D9 ( "Key=~%s~", Key );
    for ( long vKeyIdxValPos = 0; vKeyIdxValPos < (long)(*vKeyIdxVal).size(); vKeyIdxValPos++ ) {
	if ( Key == (*vKeyIdxVal)[vKeyIdxValPos].Key ) return (*vKeyIdxVal)[vKeyIdxValPos].Val.c_str();
    }

    return NULL;

}//const char *_bnRC4::GetVal ( const char *Key )


const char *_bnRC4::operator[] ( const char *Key ) {
//same as GetVal but return "";
    D9 ( "this=%p", this );

    if ( Error[0] ) return "";

    D9 ( "Key=~%s~", Key );
    for ( long vKeyIdxValPos = 0; vKeyIdxValPos < (long)(*vKeyIdxVal).size(); vKeyIdxValPos++ ) {
	if ( Key == (*vKeyIdxVal)[vKeyIdxValPos].Key ) return (*vKeyIdxVal)[vKeyIdxValPos].Val.c_str();
    }

    return "";

}//char *_bnRC4::operator[] ( char *oKey )


char *_bnRC4::cString ( void ) {
    D9 ( "this=%p", this );

_bnBlob bnBlob;
    for ( long vKeyIdxValPos = 0; vKeyIdxValPos < (long)(*vKeyIdxVal).size(); vKeyIdxValPos++ ) {
	bnBlob.Append ( (*vKeyIdxVal)[vKeyIdxValPos].Key.c_str () );
	bnBlob.Append ( "=\"" );
	bnBlob.Append ( (*vKeyIdxVal)[vKeyIdxValPos].Val.c_str () );
	bnBlob.Append ( "\"\n" );
    }

char *cStringRet = strndup ( (char *)bnBlob.data, bnBlob.len );
    return cStringRet;

}//char *_bnRC4::cString ( void )
